require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PARISC_CHECKSUM_H)) {
    eval 'sub _PARISC_CHECKSUM_H () {1;}' unless defined(&_PARISC_CHECKSUM_H);
    require 'linux/in6.ph';
    eval 'sub _HAVE_ARCH_IPV6_CSUM () {1;}' unless defined(&_HAVE_ARCH_IPV6_CSUM);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub csum_ipv6_magic {
        my($saddr,$daddr,$len,$proto,$sum) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&csum_ipv6_magic);
    eval 'sub HAVE_CSUM_COPY_USER () {1;}' unless defined(&HAVE_CSUM_COPY_USER);
    eval 'sub csum_and_copy_to_user {
        my($src,$dst,$len,$sum,$err_ptr) = @_;
	    eval q({ $sum =  &csum_partial($src, $len, $sum);  &if ( &copy_to_user($dst, $src, $len)) { *$err_ptr = - &EFAULT; -1; } $sum; });
    }' unless defined(&csum_and_copy_to_user);
}
1;
