require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_PARISC_COMPAT_H)) {
    eval 'sub _ASM_PARISC_COMPAT_H () {1;}' unless defined(&_ASM_PARISC_COMPAT_H);
    require 'linux/types.ph';
    require 'linux/sched.ph';
    eval 'sub COMPAT_USER_HZ () {100;}' unless defined(&COMPAT_USER_HZ);
    eval 'sub COMPAT_RLIM_INFINITY () {0xffffffff;}' unless defined(&COMPAT_RLIM_INFINITY);
    eval 'sub _COMPAT_NSIG () {64;}' unless defined(&_COMPAT_NSIG);
    eval 'sub _COMPAT_NSIG_BPW () {32;}' unless defined(&_COMPAT_NSIG_BPW);
    eval 'sub COMPAT_OFF_T_MAX () {0x7fffffff;}' unless defined(&COMPAT_OFF_T_MAX);
    eval 'sub COMPAT_LOFF_T_MAX () {9.22337203685478e+18;}' unless defined(&COMPAT_LOFF_T_MAX);
    eval 'sub void {
        eval q(* &compat_ptr( &compat_uptr_t  &uptr) { ( &void *) &uptr; });
    }' unless defined(&void);
    eval 'sub void {
        eval q(* &compat_alloc_user_space { \'struct pt_regs\' * &regs =  ($current->{thread}->{regs}); ( &void *) ($regs->{gr[30]}); });
    }' unless defined(&void);
}
1;
