require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&ASM_EISA_EEPROM_H)) {
    eval 'sub ASM_EISA_EEPROM_H () {1;}' unless defined(&ASM_EISA_EEPROM_H);
    eval 'sub HPEE_MAX_LENGTH () {0x2000;}' unless defined(&HPEE_MAX_LENGTH);
    eval 'sub HPEE_SLOT_INFO {
        my($slot) = @_;
	    eval q((20+(48*$slot)));
    }' unless defined(&HPEE_SLOT_INFO);
    eval 'sub HPEE_SLOT_INFO_EMBEDDED () {0x10;}' unless defined(&HPEE_SLOT_INFO_EMBEDDED);
    eval 'sub HPEE_SLOT_INFO_VIRTUAL () {0x20;}' unless defined(&HPEE_SLOT_INFO_VIRTUAL);
    eval 'sub HPEE_SLOT_INFO_NO_READID () {0x40;}' unless defined(&HPEE_SLOT_INFO_NO_READID);
    eval 'sub HPEE_SLOT_INFO_DUPLICATE () {0x80;}' unless defined(&HPEE_SLOT_INFO_DUPLICATE);
    eval 'sub HPEE_SLOT_FEATURES_ENABLE () {0x1;}' unless defined(&HPEE_SLOT_FEATURES_ENABLE);
    eval 'sub HPEE_SLOT_FEATURES_IOCHK () {0x2;}' unless defined(&HPEE_SLOT_FEATURES_IOCHK);
    eval 'sub HPEE_SLOT_FEATURES_CFG_INCOMPLETE () {0x80;}' unless defined(&HPEE_SLOT_FEATURES_CFG_INCOMPLETE);
    eval 'sub HPEE_FUNCTION_INFO_HAVE_TYPE () {0x1;}' unless defined(&HPEE_FUNCTION_INFO_HAVE_TYPE);
    eval 'sub HPEE_FUNCTION_INFO_HAVE_MEMORY () {0x2;}' unless defined(&HPEE_FUNCTION_INFO_HAVE_MEMORY);
    eval 'sub HPEE_FUNCTION_INFO_HAVE_IRQ () {0x4;}' unless defined(&HPEE_FUNCTION_INFO_HAVE_IRQ);
    eval 'sub HPEE_FUNCTION_INFO_HAVE_DMA () {0x8;}' unless defined(&HPEE_FUNCTION_INFO_HAVE_DMA);
    eval 'sub HPEE_FUNCTION_INFO_HAVE_PORT () {0x10;}' unless defined(&HPEE_FUNCTION_INFO_HAVE_PORT);
    eval 'sub HPEE_FUNCTION_INFO_HAVE_PORT_INIT () {0x20;}' unless defined(&HPEE_FUNCTION_INFO_HAVE_PORT_INIT);
    eval 'sub HPEE_FUNCTION_INFO_HAVE_FUNCTION () {0x1;}' unless defined(&HPEE_FUNCTION_INFO_HAVE_FUNCTION);
    eval 'sub HPEE_FUNCTION_INFO_F_DISABLED () {0x80;}' unless defined(&HPEE_FUNCTION_INFO_F_DISABLED);
    eval 'sub HPEE_FUNCTION_INFO_CFG_FREE_FORM () {0x40;}' unless defined(&HPEE_FUNCTION_INFO_CFG_FREE_FORM);
    eval 'sub HPEE_FLAG_BOARD_IS_ISA () {0x1;}' unless defined(&HPEE_FLAG_BOARD_IS_ISA);
    eval 'sub HPEE_MEMORY_MAX_ENT () {9;}' unless defined(&HPEE_MEMORY_MAX_ENT);
    eval 'sub HPEE_MEMORY_WRITABLE () {0x1;}' unless defined(&HPEE_MEMORY_WRITABLE);
    eval 'sub HPEE_MEMORY_CACHABLE () {0x2;}' unless defined(&HPEE_MEMORY_CACHABLE);
    eval 'sub HPEE_MEMORY_TYPE_MASK () {0x18;}' unless defined(&HPEE_MEMORY_TYPE_MASK);
    eval 'sub HPEE_MEMORY_TYPE_SYS () {0x;}' unless defined(&HPEE_MEMORY_TYPE_SYS);
    eval 'sub HPEE_MEMORY_TYPE_EXP () {0x8;}' unless defined(&HPEE_MEMORY_TYPE_EXP);
    eval 'sub HPEE_MEMORY_TYPE_VIR () {0x10;}' unless defined(&HPEE_MEMORY_TYPE_VIR);
    eval 'sub HPEE_MEMORY_TYPE_OTH () {0x18;}' unless defined(&HPEE_MEMORY_TYPE_OTH);
    eval 'sub HPEE_MEMORY_SHARED () {0x20;}' unless defined(&HPEE_MEMORY_SHARED);
    eval 'sub HPEE_MEMORY_MORE () {0x80;}' unless defined(&HPEE_MEMORY_MORE);
    eval 'sub HPEE_MEMORY_WIDTH_MASK () {0x3;}' unless defined(&HPEE_MEMORY_WIDTH_MASK);
    eval 'sub HPEE_MEMORY_WIDTH_BYTE () {0x;}' unless defined(&HPEE_MEMORY_WIDTH_BYTE);
    eval 'sub HPEE_MEMORY_WIDTH_WORD () {0x1;}' unless defined(&HPEE_MEMORY_WIDTH_WORD);
    eval 'sub HPEE_MEMORY_WIDTH_DWORD () {0x2;}' unless defined(&HPEE_MEMORY_WIDTH_DWORD);
    eval 'sub HPEE_MEMORY_DECODE_MASK () {0xc;}' unless defined(&HPEE_MEMORY_DECODE_MASK);
    eval 'sub HPEE_MEMORY_DECODE_20BITS () {0x;}' unless defined(&HPEE_MEMORY_DECODE_20BITS);
    eval 'sub HPEE_MEMORY_DECODE_24BITS () {0x4;}' unless defined(&HPEE_MEMORY_DECODE_24BITS);
    eval 'sub HPEE_MEMORY_DECODE_32BITS () {0x8;}' unless defined(&HPEE_MEMORY_DECODE_32BITS);
    eval 'sub HPEE_IRQ_MAX_ENT () {7;}' unless defined(&HPEE_IRQ_MAX_ENT);
    eval 'sub HPEE_IRQ_CHANNEL_MASK () {0xf;}' unless defined(&HPEE_IRQ_CHANNEL_MASK);
    eval 'sub HPEE_IRQ_TRIG_LEVEL () {0x20;}' unless defined(&HPEE_IRQ_TRIG_LEVEL);
    eval 'sub HPEE_IRQ_MORE () {0x80;}' unless defined(&HPEE_IRQ_MORE);
    eval 'sub HPEE_DMA_MAX_ENT () {4;}' unless defined(&HPEE_DMA_MAX_ENT);
    eval 'sub HPEE_DMA_CHANNEL_MASK () {7;}' unless defined(&HPEE_DMA_CHANNEL_MASK);
    eval 'sub HPEE_DMA_SIZE_MASK () {0xc;}' unless defined(&HPEE_DMA_SIZE_MASK);
    eval 'sub HPEE_DMA_SIZE_BYTE () {0x;}' unless defined(&HPEE_DMA_SIZE_BYTE);
    eval 'sub HPEE_DMA_SIZE_WORD () {0x4;}' unless defined(&HPEE_DMA_SIZE_WORD);
    eval 'sub HPEE_DMA_SIZE_DWORD () {0x8;}' unless defined(&HPEE_DMA_SIZE_DWORD);
    eval 'sub HPEE_DMA_SHARED () {0x40;}' unless defined(&HPEE_DMA_SHARED);
    eval 'sub HPEE_DMA_MORE () {0x80;}' unless defined(&HPEE_DMA_MORE);
    eval 'sub HPEE_DMA_TIMING_MASK () {0x30;}' unless defined(&HPEE_DMA_TIMING_MASK);
    eval 'sub HPEE_DMA_TIMING_ISA () {0x;}' unless defined(&HPEE_DMA_TIMING_ISA);
    eval 'sub HPEE_DMA_TIMING_TYPEA () {0x10;}' unless defined(&HPEE_DMA_TIMING_TYPEA);
    eval 'sub HPEE_DMA_TIMING_TYPEB () {0x20;}' unless defined(&HPEE_DMA_TIMING_TYPEB);
    eval 'sub HPEE_DMA_TIMING_TYPEC () {0x30;}' unless defined(&HPEE_DMA_TIMING_TYPEC);
    eval 'sub HPEE_PORT_MAX_ENT () {20;}' unless defined(&HPEE_PORT_MAX_ENT);
    eval 'sub HPEE_PORT_SIZE_MASK () {0x1f;}' unless defined(&HPEE_PORT_SIZE_MASK);
    eval 'sub HPEE_PORT_SHARED () {0x40;}' unless defined(&HPEE_PORT_SHARED);
    eval 'sub HPEE_PORT_MORE () {0x80;}' unless defined(&HPEE_PORT_MORE);
    eval 'sub HPEE_PORT_INIT_MAX_LEN () {60;}' unless defined(&HPEE_PORT_INIT_MAX_LEN);
    eval 'sub HPEE_PORT_INIT_WIDTH_MASK () {0x3;}' unless defined(&HPEE_PORT_INIT_WIDTH_MASK);
    eval 'sub HPEE_PORT_INIT_WIDTH_BYTE () {0x;}' unless defined(&HPEE_PORT_INIT_WIDTH_BYTE);
    eval 'sub HPEE_PORT_INIT_WIDTH_WORD () {0x1;}' unless defined(&HPEE_PORT_INIT_WIDTH_WORD);
    eval 'sub HPEE_PORT_INIT_WIDTH_DWORD () {0x2;}' unless defined(&HPEE_PORT_INIT_WIDTH_DWORD);
    eval 'sub HPEE_PORT_INIT_MASK () {0x4;}' unless defined(&HPEE_PORT_INIT_MASK);
    eval 'sub HPEE_PORT_INIT_MORE () {0x80;}' unless defined(&HPEE_PORT_INIT_MORE);
    eval 'sub HPEE_SELECTION_MAX_ENT () {26;}' unless defined(&HPEE_SELECTION_MAX_ENT);
    eval 'sub HPEE_TYPE_MAX_LEN () {80;}' unless defined(&HPEE_TYPE_MAX_LEN);
}
1;
