require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASMPARISC_ELF_H)) {
    eval 'sub __ASMPARISC_ELF_H () {1;}' unless defined(&__ASMPARISC_ELF_H);
    require 'asm/ptrace.ph';
    eval 'sub EM_PARISC () {15;}' unless defined(&EM_PARISC);
    eval 'sub EF_PARISC_TRAPNIL () {0x10000;}' unless defined(&EF_PARISC_TRAPNIL);
    eval 'sub EF_PARISC_EXT () {0x20000;}' unless defined(&EF_PARISC_EXT);
    eval 'sub EF_PARISC_LSB () {0x40000;}' unless defined(&EF_PARISC_LSB);
    eval 'sub EF_PARISC_WIDE () {0x80000;}' unless defined(&EF_PARISC_WIDE);
    eval 'sub EF_PARISC_NO_KABP () {0x100000;}' unless defined(&EF_PARISC_NO_KABP);
    eval 'sub EF_PARISC_LAZYSWAP () {0x400000;}' unless defined(&EF_PARISC_LAZYSWAP);
    eval 'sub EF_PARISC_ARCH () {0xffff;}' unless defined(&EF_PARISC_ARCH);
    eval 'sub EFA_PARISC_1_0 () {0x20b;}' unless defined(&EFA_PARISC_1_0);
    eval 'sub EFA_PARISC_1_1 () {0x210;}' unless defined(&EFA_PARISC_1_1);
    eval 'sub EFA_PARISC_2_0 () {0x214;}' unless defined(&EFA_PARISC_2_0);
    eval 'sub SHN_PARISC_ANSI_COMMON () {0xff00;}' unless defined(&SHN_PARISC_ANSI_COMMON);
    eval 'sub SHN_PARISC_HUGE_COMMON () {0xff01;}' unless defined(&SHN_PARISC_HUGE_COMMON);
    eval 'sub SHT_PARISC_EXT () {0x70000000;}' unless defined(&SHT_PARISC_EXT);
    eval 'sub SHT_PARISC_UNWIND () {0x70000001;}' unless defined(&SHT_PARISC_UNWIND);
    eval 'sub SHT_PARISC_DOC () {0x70000002;}' unless defined(&SHT_PARISC_DOC);
    eval 'sub SHF_PARISC_SHORT () {0x20000000;}' unless defined(&SHF_PARISC_SHORT);
    eval 'sub SHF_PARISC_HUGE () {0x40000000;}' unless defined(&SHF_PARISC_HUGE);
    eval 'sub SHF_PARISC_SBP () {0x80000000;}' unless defined(&SHF_PARISC_SBP);
    eval 'sub STT_PARISC_MILLICODE () {13;}' unless defined(&STT_PARISC_MILLICODE);
    eval 'sub STT_HP_OPAQUE () {( &STT_LOOS + 0x1);}' unless defined(&STT_HP_OPAQUE);
    eval 'sub STT_HP_STUB () {( &STT_LOOS + 0x2);}' unless defined(&STT_HP_STUB);
    eval 'sub R_PARISC_NONE () {0;}' unless defined(&R_PARISC_NONE);
    eval 'sub R_PARISC_DIR32 () {1;}' unless defined(&R_PARISC_DIR32);
    eval 'sub R_PARISC_DIR21L () {2;}' unless defined(&R_PARISC_DIR21L);
    eval 'sub R_PARISC_DIR17R () {3;}' unless defined(&R_PARISC_DIR17R);
    eval 'sub R_PARISC_DIR17F () {4;}' unless defined(&R_PARISC_DIR17F);
    eval 'sub R_PARISC_DIR14R () {6;}' unless defined(&R_PARISC_DIR14R);
    eval 'sub R_PARISC_PCREL32 () {9;}' unless defined(&R_PARISC_PCREL32);
    eval 'sub R_PARISC_PCREL21L () {10;}' unless defined(&R_PARISC_PCREL21L);
    eval 'sub R_PARISC_PCREL17R () {11;}' unless defined(&R_PARISC_PCREL17R);
    eval 'sub R_PARISC_PCREL17F () {12;}' unless defined(&R_PARISC_PCREL17F);
    eval 'sub R_PARISC_PCREL14R () {14;}' unless defined(&R_PARISC_PCREL14R);
    eval 'sub R_PARISC_DPREL21L () {18;}' unless defined(&R_PARISC_DPREL21L);
    eval 'sub R_PARISC_DPREL14R () {22;}' unless defined(&R_PARISC_DPREL14R);
    eval 'sub R_PARISC_GPREL21L () {26;}' unless defined(&R_PARISC_GPREL21L);
    eval 'sub R_PARISC_GPREL14R () {30;}' unless defined(&R_PARISC_GPREL14R);
    eval 'sub R_PARISC_LTOFF21L () {34;}' unless defined(&R_PARISC_LTOFF21L);
    eval 'sub R_PARISC_LTOFF14R () {38;}' unless defined(&R_PARISC_LTOFF14R);
    eval 'sub R_PARISC_SECREL32 () {41;}' unless defined(&R_PARISC_SECREL32);
    eval 'sub R_PARISC_SEGBASE () {48;}' unless defined(&R_PARISC_SEGBASE);
    eval 'sub R_PARISC_SEGREL32 () {49;}' unless defined(&R_PARISC_SEGREL32);
    eval 'sub R_PARISC_PLTOFF21L () {50;}' unless defined(&R_PARISC_PLTOFF21L);
    eval 'sub R_PARISC_PLTOFF14R () {54;}' unless defined(&R_PARISC_PLTOFF14R);
    eval 'sub R_PARISC_LTOFF_FPTR32 () {57;}' unless defined(&R_PARISC_LTOFF_FPTR32);
    eval 'sub R_PARISC_LTOFF_FPTR21L () {58;}' unless defined(&R_PARISC_LTOFF_FPTR21L);
    eval 'sub R_PARISC_LTOFF_FPTR14R () {62;}' unless defined(&R_PARISC_LTOFF_FPTR14R);
    eval 'sub R_PARISC_FPTR64 () {64;}' unless defined(&R_PARISC_FPTR64);
    eval 'sub R_PARISC_PLABEL32 () {65;}' unless defined(&R_PARISC_PLABEL32);
    eval 'sub R_PARISC_PCREL64 () {72;}' unless defined(&R_PARISC_PCREL64);
    eval 'sub R_PARISC_PCREL22F () {74;}' unless defined(&R_PARISC_PCREL22F);
    eval 'sub R_PARISC_PCREL14WR () {75;}' unless defined(&R_PARISC_PCREL14WR);
    eval 'sub R_PARISC_PCREL14DR () {76;}' unless defined(&R_PARISC_PCREL14DR);
    eval 'sub R_PARISC_PCREL16F () {77;}' unless defined(&R_PARISC_PCREL16F);
    eval 'sub R_PARISC_PCREL16WF () {78;}' unless defined(&R_PARISC_PCREL16WF);
    eval 'sub R_PARISC_PCREL16DF () {79;}' unless defined(&R_PARISC_PCREL16DF);
    eval 'sub R_PARISC_DIR64 () {80;}' unless defined(&R_PARISC_DIR64);
    eval 'sub R_PARISC_DIR14WR () {83;}' unless defined(&R_PARISC_DIR14WR);
    eval 'sub R_PARISC_DIR14DR () {84;}' unless defined(&R_PARISC_DIR14DR);
    eval 'sub R_PARISC_DIR16F () {85;}' unless defined(&R_PARISC_DIR16F);
    eval 'sub R_PARISC_DIR16WF () {86;}' unless defined(&R_PARISC_DIR16WF);
    eval 'sub R_PARISC_DIR16DF () {87;}' unless defined(&R_PARISC_DIR16DF);
    eval 'sub R_PARISC_GPREL64 () {88;}' unless defined(&R_PARISC_GPREL64);
    eval 'sub R_PARISC_GPREL14WR () {91;}' unless defined(&R_PARISC_GPREL14WR);
    eval 'sub R_PARISC_GPREL14DR () {92;}' unless defined(&R_PARISC_GPREL14DR);
    eval 'sub R_PARISC_GPREL16F () {93;}' unless defined(&R_PARISC_GPREL16F);
    eval 'sub R_PARISC_GPREL16WF () {94;}' unless defined(&R_PARISC_GPREL16WF);
    eval 'sub R_PARISC_GPREL16DF () {95;}' unless defined(&R_PARISC_GPREL16DF);
    eval 'sub R_PARISC_LTOFF64 () {96;}' unless defined(&R_PARISC_LTOFF64);
    eval 'sub R_PARISC_LTOFF14WR () {99;}' unless defined(&R_PARISC_LTOFF14WR);
    eval 'sub R_PARISC_LTOFF14DR () {100;}' unless defined(&R_PARISC_LTOFF14DR);
    eval 'sub R_PARISC_LTOFF16F () {101;}' unless defined(&R_PARISC_LTOFF16F);
    eval 'sub R_PARISC_LTOFF16WF () {102;}' unless defined(&R_PARISC_LTOFF16WF);
    eval 'sub R_PARISC_LTOFF16DF () {103;}' unless defined(&R_PARISC_LTOFF16DF);
    eval 'sub R_PARISC_SECREL64 () {104;}' unless defined(&R_PARISC_SECREL64);
    eval 'sub R_PARISC_SEGREL64 () {112;}' unless defined(&R_PARISC_SEGREL64);
    eval 'sub R_PARISC_PLTOFF14WR () {115;}' unless defined(&R_PARISC_PLTOFF14WR);
    eval 'sub R_PARISC_PLTOFF14DR () {116;}' unless defined(&R_PARISC_PLTOFF14DR);
    eval 'sub R_PARISC_PLTOFF16F () {117;}' unless defined(&R_PARISC_PLTOFF16F);
    eval 'sub R_PARISC_PLTOFF16WF () {118;}' unless defined(&R_PARISC_PLTOFF16WF);
    eval 'sub R_PARISC_PLTOFF16DF () {119;}' unless defined(&R_PARISC_PLTOFF16DF);
    eval 'sub R_PARISC_LTOFF_FPTR64 () {120;}' unless defined(&R_PARISC_LTOFF_FPTR64);
    eval 'sub R_PARISC_LTOFF_FPTR14WR () {123;}' unless defined(&R_PARISC_LTOFF_FPTR14WR);
    eval 'sub R_PARISC_LTOFF_FPTR14DR () {124;}' unless defined(&R_PARISC_LTOFF_FPTR14DR);
    eval 'sub R_PARISC_LTOFF_FPTR16F () {125;}' unless defined(&R_PARISC_LTOFF_FPTR16F);
    eval 'sub R_PARISC_LTOFF_FPTR16WF () {126;}' unless defined(&R_PARISC_LTOFF_FPTR16WF);
    eval 'sub R_PARISC_LTOFF_FPTR16DF () {127;}' unless defined(&R_PARISC_LTOFF_FPTR16DF);
    eval 'sub R_PARISC_LORESERVE () {128;}' unless defined(&R_PARISC_LORESERVE);
    eval 'sub R_PARISC_COPY () {128;}' unless defined(&R_PARISC_COPY);
    eval 'sub R_PARISC_IPLT () {129;}' unless defined(&R_PARISC_IPLT);
    eval 'sub R_PARISC_EPLT () {130;}' unless defined(&R_PARISC_EPLT);
    eval 'sub R_PARISC_TPREL32 () {153;}' unless defined(&R_PARISC_TPREL32);
    eval 'sub R_PARISC_TPREL21L () {154;}' unless defined(&R_PARISC_TPREL21L);
    eval 'sub R_PARISC_TPREL14R () {158;}' unless defined(&R_PARISC_TPREL14R);
    eval 'sub R_PARISC_LTOFF_TP21L () {162;}' unless defined(&R_PARISC_LTOFF_TP21L);
    eval 'sub R_PARISC_LTOFF_TP14R () {166;}' unless defined(&R_PARISC_LTOFF_TP14R);
    eval 'sub R_PARISC_LTOFF_TP14F () {167;}' unless defined(&R_PARISC_LTOFF_TP14F);
    eval 'sub R_PARISC_TPREL64 () {216;}' unless defined(&R_PARISC_TPREL64);
    eval 'sub R_PARISC_TPREL14WR () {219;}' unless defined(&R_PARISC_TPREL14WR);
    eval 'sub R_PARISC_TPREL14DR () {220;}' unless defined(&R_PARISC_TPREL14DR);
    eval 'sub R_PARISC_TPREL16F () {221;}' unless defined(&R_PARISC_TPREL16F);
    eval 'sub R_PARISC_TPREL16WF () {222;}' unless defined(&R_PARISC_TPREL16WF);
    eval 'sub R_PARISC_TPREL16DF () {223;}' unless defined(&R_PARISC_TPREL16DF);
    eval 'sub R_PARISC_LTOFF_TP64 () {224;}' unless defined(&R_PARISC_LTOFF_TP64);
    eval 'sub R_PARISC_LTOFF_TP14WR () {227;}' unless defined(&R_PARISC_LTOFF_TP14WR);
    eval 'sub R_PARISC_LTOFF_TP14DR () {228;}' unless defined(&R_PARISC_LTOFF_TP14DR);
    eval 'sub R_PARISC_LTOFF_TP16F () {229;}' unless defined(&R_PARISC_LTOFF_TP16F);
    eval 'sub R_PARISC_LTOFF_TP16WF () {230;}' unless defined(&R_PARISC_LTOFF_TP16WF);
    eval 'sub R_PARISC_LTOFF_TP16DF () {231;}' unless defined(&R_PARISC_LTOFF_TP16DF);
    eval 'sub R_PARISC_HIRESERVE () {255;}' unless defined(&R_PARISC_HIRESERVE);
    eval 'sub PA_PLABEL_FDESC () {0x2;}' unless defined(&PA_PLABEL_FDESC);
    eval 'sub PT_HP_TLS () {( &PT_LOOS + 0x);}' unless defined(&PT_HP_TLS);
    eval 'sub PT_HP_CORE_NONE () {( &PT_LOOS + 0x1);}' unless defined(&PT_HP_CORE_NONE);
    eval 'sub PT_HP_CORE_VERSION () {( &PT_LOOS + 0x2);}' unless defined(&PT_HP_CORE_VERSION);
    eval 'sub PT_HP_CORE_KERNEL () {( &PT_LOOS + 0x3);}' unless defined(&PT_HP_CORE_KERNEL);
    eval 'sub PT_HP_CORE_COMM () {( &PT_LOOS + 0x4);}' unless defined(&PT_HP_CORE_COMM);
    eval 'sub PT_HP_CORE_PROC () {( &PT_LOOS + 0x5);}' unless defined(&PT_HP_CORE_PROC);
    eval 'sub PT_HP_CORE_LOADABLE () {( &PT_LOOS + 0x6);}' unless defined(&PT_HP_CORE_LOADABLE);
    eval 'sub PT_HP_CORE_STACK () {( &PT_LOOS + 0x7);}' unless defined(&PT_HP_CORE_STACK);
    eval 'sub PT_HP_CORE_SHM () {( &PT_LOOS + 0x8);}' unless defined(&PT_HP_CORE_SHM);
    eval 'sub PT_HP_CORE_MMF () {( &PT_LOOS + 0x9);}' unless defined(&PT_HP_CORE_MMF);
    eval 'sub PT_HP_PARALLEL () {( &PT_LOOS + 0x10);}' unless defined(&PT_HP_PARALLEL);
    eval 'sub PT_HP_FASTBIND () {( &PT_LOOS + 0x11);}' unless defined(&PT_HP_FASTBIND);
    eval 'sub PT_HP_OPT_ANNOT () {( &PT_LOOS + 0x12);}' unless defined(&PT_HP_OPT_ANNOT);
    eval 'sub PT_HP_HSL_ANNOT () {( &PT_LOOS + 0x13);}' unless defined(&PT_HP_HSL_ANNOT);
    eval 'sub PT_HP_STACK () {( &PT_LOOS + 0x14);}' unless defined(&PT_HP_STACK);
    eval 'sub PT_PARISC_ARCHEXT () {0x70000000;}' unless defined(&PT_PARISC_ARCHEXT);
    eval 'sub PT_PARISC_UNWIND () {0x70000001;}' unless defined(&PT_PARISC_UNWIND);
    eval 'sub PF_PARISC_SBP () {0x8000000;}' unless defined(&PF_PARISC_SBP);
    eval 'sub PF_HP_PAGE_SIZE () {0x100000;}' unless defined(&PF_HP_PAGE_SIZE);
    eval 'sub PF_HP_FAR_SHARED () {0x200000;}' unless defined(&PF_HP_FAR_SHARED);
    eval 'sub PF_HP_NEAR_SHARED () {0x400000;}' unless defined(&PF_HP_NEAR_SHARED);
    eval 'sub PF_HP_CODE () {0x1000000;}' unless defined(&PF_HP_CODE);
    eval 'sub PF_HP_MODIFY () {0x2000000;}' unless defined(&PF_HP_MODIFY);
    eval 'sub PF_HP_LAZYSWAP () {0x4000000;}' unless defined(&PF_HP_LAZYSWAP);
    eval 'sub PF_HP_SBP () {0x8000000;}' unless defined(&PF_HP_SBP);
    unless(defined(&ELF_CLASS)) {
	if(defined(&__LP64__)) {
	    eval 'sub ELF_CLASS () { &ELFCLASS64;}' unless defined(&ELF_CLASS);
	} else {
	    eval 'sub ELF_CLASS () { &ELFCLASS32;}' unless defined(&ELF_CLASS);
	}
	eval 'sub ELF_PLATFORM () {("PARISC\\0" );}' unless defined(&ELF_PLATFORM);
	if(defined(&__KERNEL__)) {
	    eval 'sub SET_PERSONALITY {
	        my($ex, $ibcs2) = @_;
    		eval q( ($current->{personality}) =  &PER_LINUX;  ($current->{thread}->{map_base}) =  &DEFAULT_MAP_BASE;  ($current->{thread}->{task_size}) =  &DEFAULT_TASK_SIZE);
	    }' unless defined(&SET_PERSONALITY);
	}
	eval 'sub ELF_CORE_COPY_REGS {
	    my($dst, $pt) = @_;
    	    eval q( &memset($dst, 0, $sizeof{$dst});  &memcpy($dst + 0,  ($pt->{gr}), 32* $sizeof{ &elf_greg_t});  &memcpy($dst + 32,  ($pt->{sr}), 8* $sizeof{ &elf_greg_t});  &memcpy($dst + 40,  ($pt->{iaoq}), 2* $sizeof{ &elf_greg_t});  &memcpy($dst + 42,  ($pt->{iasq}), 2* $sizeof{ &elf_greg_t}); $dst->[44] =  ($pt->{sar}); $dst->[45] =  ($pt->{iir}); $dst->[46] =  ($pt->{isr}); $dst->[47] =  ($pt->{ior}); $dst->[48] =  &mfctl(22); $dst->[49] =  &mfctl(0); $dst->[50] =  &mfctl(24); $dst->[51] =  &mfctl(25); $dst->[52] =  &mfctl(26); $dst->[53] =  &mfctl(27); $dst->[54] =  &mfctl(28); $dst->[55] =  &mfctl(29); $dst->[56] =  &mfctl(30); $dst->[57] =  &mfctl(31); $dst->[58] =  &mfctl( 8); $dst->[59] =  &mfctl( 9); $dst->[60] =  &mfctl(12); $dst->[61] =  &mfctl(13); $dst->[62] =  &mfctl(10); $dst->[63] =  &mfctl(15););
	}' unless defined(&ELF_CORE_COPY_REGS);
    }
    eval 'sub ELF_NGREG () {80;}' unless defined(&ELF_NGREG);
    eval 'sub ELF_NFPREG () {32;}' unless defined(&ELF_NFPREG);
    eval 'sub ELF_CORE_COPY_FPREGS {
        my($tsk, $elf_fpregs) = @_;
	    eval q( &dump_task_fpu($tsk, $elf_fpregs));
    }' unless defined(&ELF_CORE_COPY_FPREGS);
    eval 'sub elf_check_arch {
        my($x) = @_;
	    eval q((($x)-> &e_machine ==  &EM_PARISC  && ($x)-> $e_ident[ &EI_CLASS] ==  &ELF_CLASS));
    }' unless defined(&elf_check_arch);
    eval 'sub ELF_DATA () { &ELFDATA2MSB;}' unless defined(&ELF_DATA);
    eval 'sub ELF_ARCH () { &EM_PARISC;}' unless defined(&ELF_ARCH);
    eval 'sub ELF_OSABI () { &ELFOSABI_LINUX;}' unless defined(&ELF_OSABI);
    eval 'sub ELF_PLAT_INIT {
        my($_r, $load_addr) = @_;
	    eval q( ($_r->{gr[23]}) = 0);
    }' unless defined(&ELF_PLAT_INIT);
    eval 'sub USE_ELF_CORE_DUMP () {1;}' unless defined(&USE_ELF_CORE_DUMP);
    eval 'sub ELF_EXEC_PAGESIZE () {4096;}' unless defined(&ELF_EXEC_PAGESIZE);
    eval 'sub ELF_ET_DYN_BASE () {( &TASK_UNMAPPED_BASE + 0x1000000);}' unless defined(&ELF_ET_DYN_BASE);
    eval 'sub ELF_HWCAP () {0;}' unless defined(&ELF_HWCAP);
}
1;
