require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_PARISC_IDE_H)) {
    eval 'sub __ASM_PARISC_IDE_H () {1;}' unless defined(&__ASM_PARISC_IDE_H);
    if(defined(&__KERNEL__)) {
	require 'linux/config.ph';
	unless(defined(&MAX_HWIFS)) {
	    eval 'sub MAX_HWIFS () {2;}' unless defined(&MAX_HWIFS);
	}
	eval 'sub IDE_ARCH_OBSOLETE_INIT () {1;}' unless defined(&IDE_ARCH_OBSOLETE_INIT);
	eval 'sub ide_default_io_ctl {
	    my($base) = @_;
    	    eval q((($base) + 0x206));
	}' unless defined(&ide_default_io_ctl);
	eval 'sub ide_request_irq {
	    my($irq,$hand,$flg,$dev,$id) = @_;
    	    eval q( &request_irq(($irq),($hand),($flg),($dev),($id)));
	}' unless defined(&ide_request_irq);
	eval 'sub ide_free_irq {
	    my($irq,$dev_id) = @_;
    	    eval q( &free_irq(($irq), ($dev_id)));
	}' unless defined(&ide_free_irq);
	eval 'sub ide_check_region {
	    my($from,$extent) = @_;
    	    eval q( &check_region(($from), ($extent)));
	}' unless defined(&ide_check_region);
	eval 'sub ide_request_region {
	    my($from,$extent,$name) = @_;
    	    eval q( &request_region(($from), ($extent), ($name)));
	}' unless defined(&ide_request_region);
	eval 'sub ide_release_region {
	    my($from,$extent) = @_;
    	    eval q( &release_region(($from), ($extent)));
	}' unless defined(&ide_release_region);
	eval 'sub __ide_insw () { &insw;}' unless defined(&__ide_insw);
	eval 'sub __ide_insl () { &insl;}' unless defined(&__ide_insl);
	eval 'sub __ide_outsw () { &outsw;}' unless defined(&__ide_outsw);
	eval 'sub __ide_outsl () { &outsl;}' unless defined(&__ide_outsl);
	eval 'sub __ide_mm_insw {
	    my($port,$addr,$count) = @_;
    	    eval q({  &while ($count--) { *( &u16 *)$addr =  &__raw_readw($port); $addr += 2; } });
	}' unless defined(&__ide_mm_insw);
	eval 'sub __ide_mm_insl {
	    my($port,$addr,$count) = @_;
    	    eval q({  &while ($count--) { *( &u32 *)$addr =  &__raw_readl($port); $addr += 4; } });
	}' unless defined(&__ide_mm_insl);
	eval 'sub __ide_mm_outsw {
	    my($port,$addr,$count) = @_;
    	    eval q({  &while ($count--) {  &__raw_writew(*( &u16 *)$addr, $port); $addr += 2; } });
	}' unless defined(&__ide_mm_outsw);
	eval 'sub __ide_mm_outsl {
	    my($port,$addr,$count) = @_;
    	    eval q({  &while ($count--) {  &__raw_writel(*( &u32 *)$addr, $port); $addr += 4; } });
	}' unless defined(&__ide_mm_outsl);
    }
}
1;
