require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_PERF_H_)) {
    eval 'sub _ASM_PERF_H_ () {1;}' unless defined(&_ASM_PERF_H_);
    eval 'sub PA_PERF_ON () { &_IO(ord(\'p\'), 1);}' unless defined(&PA_PERF_ON);
    eval 'sub PA_PERF_OFF () { &_IOR(ord(\'p\'), 2, \'unsigned int\');}' unless defined(&PA_PERF_OFF);
    eval 'sub PA_PERF_VERSION () { &_IOR(ord(\'p\'), 3, \'int\');}' unless defined(&PA_PERF_VERSION);
    eval 'sub PA_PERF_DEV () {"perf";}' unless defined(&PA_PERF_DEV);
    eval 'sub PA_PERF_MINOR () {146;}' unless defined(&PA_PERF_MINOR);
    eval 'sub UNKNOWN_INTF () {255;}' unless defined(&UNKNOWN_INTF);
    eval 'sub ONYX_INTF () {0;}' unless defined(&ONYX_INTF);
    eval 'sub CUDA_INTF () {1;}' unless defined(&CUDA_INTF);
    eval 'sub CPI () {0;}' unless defined(&CPI);
    eval 'sub BUSUTIL () {1;}' unless defined(&BUSUTIL);
    eval 'sub TLBMISS () {2;}' unless defined(&TLBMISS);
    eval 'sub TLBHANDMISS () {3;}' unless defined(&TLBHANDMISS);
    eval 'sub PTKN () {4;}' unless defined(&PTKN);
    eval 'sub PNTKN () {5;}' unless defined(&PNTKN);
    eval 'sub IMISS () {6;}' unless defined(&IMISS);
    eval 'sub DMISS () {7;}' unless defined(&DMISS);
    eval 'sub DMISS_ACCESS () {8;}' unless defined(&DMISS_ACCESS);
    eval 'sub BIG_CPI () {9;}' unless defined(&BIG_CPI);
    eval 'sub BIG_LS () {10;}' unless defined(&BIG_LS);
    eval 'sub BR_ABORT () {11;}' unless defined(&BR_ABORT);
    eval 'sub ISNT () {12;}' unless defined(&ISNT);
    eval 'sub QUADRANT () {13;}' unless defined(&QUADRANT);
    eval 'sub RW_PDFET () {14;}' unless defined(&RW_PDFET);
    eval 'sub RW_WDFET () {15;}' unless defined(&RW_WDFET);
    eval 'sub SHLIB_CPI () {16;}' unless defined(&SHLIB_CPI);
    eval 'sub FLOPS () {17;}' unless defined(&FLOPS);
    eval 'sub CACHEMISS () {18;}' unless defined(&CACHEMISS);
    eval 'sub BRANCHES () {19;}' unless defined(&BRANCHES);
    eval 'sub CRSTACK () {20;}' unless defined(&CRSTACK);
    eval 'sub I_CACHE_SPEC () {21;}' unless defined(&I_CACHE_SPEC);
    eval 'sub MAX_CUDA_IMAGES () {22;}' unless defined(&MAX_CUDA_IMAGES);
    eval 'sub ADDR_INV_ABORT_ALU () {17;}' unless defined(&ADDR_INV_ABORT_ALU);
    eval 'sub BRAD_STALL () {18;}' unless defined(&BRAD_STALL);
    eval 'sub CNTL_IN_PIPEL () {19;}' unless defined(&CNTL_IN_PIPEL);
    eval 'sub DSNT_XFH () {20;}' unless defined(&DSNT_XFH);
    eval 'sub FET_SIG1 () {21;}' unless defined(&FET_SIG1);
    eval 'sub FET_SIG2 () {22;}' unless defined(&FET_SIG2);
    eval 'sub G7_1 () {23;}' unless defined(&G7_1);
    eval 'sub G7_2 () {24;}' unless defined(&G7_2);
    eval 'sub G7_3 () {25;}' unless defined(&G7_3);
    eval 'sub G7_4 () {26;}' unless defined(&G7_4);
    eval 'sub MPB_LABORT () {27;}' unless defined(&MPB_LABORT);
    eval 'sub PANIC () {28;}' unless defined(&PANIC);
    eval 'sub RARE_INST () {29;}' unless defined(&RARE_INST);
    eval 'sub RW_DFET () {30;}' unless defined(&RW_DFET);
    eval 'sub RW_IFET () {31;}' unless defined(&RW_IFET);
    eval 'sub RW_SDFET () {32;}' unless defined(&RW_SDFET);
    eval 'sub SPEC_IFET () {33;}' unless defined(&SPEC_IFET);
    eval 'sub ST_COND0 () {34;}' unless defined(&ST_COND0);
    eval 'sub ST_COND1 () {35;}' unless defined(&ST_COND1);
    eval 'sub ST_COND2 () {36;}' unless defined(&ST_COND2);
    eval 'sub ST_COND3 () {37;}' unless defined(&ST_COND3);
    eval 'sub ST_COND4 () {38;}' unless defined(&ST_COND4);
    eval 'sub ST_UNPRED0 () {39;}' unless defined(&ST_UNPRED0);
    eval 'sub ST_UNPRED1 () {40;}' unless defined(&ST_UNPRED1);
    eval 'sub UNPRED () {41;}' unless defined(&UNPRED);
    eval 'sub GO_STORE () {42;}' unless defined(&GO_STORE);
    eval 'sub SHLIB_CALL () {43;}' unless defined(&SHLIB_CALL);
    eval 'sub MAX_ONYX_IMAGES () {44;}' unless defined(&MAX_ONYX_IMAGES);
}
1;
