require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_PGALLOC_H)) {
    eval 'sub _ASM_PGALLOC_H () {1;}' unless defined(&_ASM_PGALLOC_H);
    require 'linux/gfp.ph';
    require 'linux/mm.ph';
    require 'linux/threads.ph';
    require 'asm/processor.ph';
    require 'asm/fixmap.ph';
    require 'asm/pgtable.ph';
    require 'asm/cache.ph';
    if(defined(&__LP64__)) {
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub pgd_free {
        my($pgd) = @_;
	    eval q({  &free_pages($pgd,  &PGD_ALLOC_ORDER); });
    }' unless defined(&pgd_free);
    if((defined(&PT_NLEVELS) ? &PT_NLEVELS : 0) == 3) {
	eval 'sub pmd_t {
	    eval q(* &pmd_alloc_one(\'struct mm_struct\' * &mm, my $address) {  &pmd_t * &pmd = ( &pmd_t *) &__get_free_pages( &GFP_KERNEL| &__GFP_REPEAT,  &PMD_ORDER);  &if ( &pmd)  &memset( &pmd, 0,  &PAGE_SIZE<< &PMD_ORDER);  &pmd; });
	}' unless defined(&pmd_t);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub pmd_free {
	    my($pmd) = @_;
    	    eval q({  &free_pages($pmd,  &PMD_ORDER); });
	}' unless defined(&pmd_free);
    } else {
	eval 'sub pmd_alloc_one {
	    my($mm, $addr) = @_;
    	    eval q(({  &BUG(); (( &pmd_t *)2); }));
	}' unless defined(&pmd_alloc_one);
	eval 'sub pmd_free {
	    my($x) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&pmd_free);
	eval 'sub pgd_populate {
	    my($mm, $pmd, $pte) = @_;
    	    eval q( &BUG());
	}' unless defined(&pgd_populate);
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub pmd_populate_kernel {
        my($mm,$pmd,$pte) = @_;
	    eval q({  &__pmd_val_set(*$pmd, ( &PxD_FLAG_PRESENT |  &PxD_FLAG_VALID) + ( &__u32)( &__pa($pte) >>  &PxD_VALUE_SHIFT)); });
    }' unless defined(&pmd_populate_kernel);
    eval 'sub pmd_populate {
        my($mm, $pmd, $pte_page) = @_;
	    eval q( &pmd_populate_kernel($mm, $pmd,  &page_address($pte_page)));
    }' unless defined(&pmd_populate);
    eval 'sub pte_alloc_one {
        my($mm,$address) = @_;
	    eval q({ \'struct page\' * &page =  &alloc_page( &GFP_KERNEL| &__GFP_REPEAT| &__GFP_ZERO);  &page; });
    }' unless defined(&pte_alloc_one);
    eval 'sub pte_alloc_one_kernel {
        my($mm,$addr) = @_;
	    eval q({  &pte_t * &pte = ( &pte_t *) &__get_free_page( &GFP_KERNEL| &__GFP_REPEAT| &__GFP_ZERO);  &pte; });
    }' unless defined(&pte_alloc_one_kernel);
    eval 'sub pte_free_kernel {
        my($pte) = @_;
	    eval q({  &free_page($pte); });
    }' unless defined(&pte_free_kernel);
    eval 'sub pte_free {
        my($page) = @_;
	    eval q( &pte_free_kernel( &page_address($page)));
    }' unless defined(&pte_free);
    eval 'sub check_pgt_cache () {
        eval q( &do { }  &while (0));
    }' unless defined(&check_pgt_cache);
}
1;
