require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_PARISC_SEMAPHORE_H)) {
    eval 'sub _ASM_PARISC_SEMAPHORE_H () {1;}' unless defined(&_ASM_PARISC_SEMAPHORE_H);
    require 'linux/spinlock.ph';
    require 'linux/wait.ph';
    require 'linux/rwsem.ph';
    require 'asm/system.ph';
    eval 'sub __SEMAPHORE_INITIALIZER {
        my($name, $n) = @_;
	    eval q({ . &sentry =  &SPIN_LOCK_UNLOCKED, . &count = $n, . &wait =  &__WAIT_QUEUE_HEAD_INITIALIZER(($name). &wait) });
    }' unless defined(&__SEMAPHORE_INITIALIZER);
    eval 'sub __MUTEX_INITIALIZER {
        my($name) = @_;
	    eval q( &__SEMAPHORE_INITIALIZER($name,1));
    }' unless defined(&__MUTEX_INITIALIZER);
    eval 'sub __DECLARE_SEMAPHORE_GENERIC {
        my($name,$count) = @_;
	    eval q(\'struct semaphore\' $name =  &__SEMAPHORE_INITIALIZER($name,$count));
    }' unless defined(&__DECLARE_SEMAPHORE_GENERIC);
    eval 'sub DECLARE_MUTEX {
        my($name) = @_;
	    eval q( &__DECLARE_SEMAPHORE_GENERIC($name,1));
    }' unless defined(&DECLARE_MUTEX);
    eval 'sub DECLARE_MUTEX_LOCKED {
        my($name) = @_;
	    eval q( &__DECLARE_SEMAPHORE_GENERIC($name,0));
    }' unless defined(&DECLARE_MUTEX_LOCKED);
    eval 'sub init_MUTEX {
        my($sem) = @_;
	    eval q({  &sema_init($sem, 1); });
    }' unless defined(&init_MUTEX);
    eval 'sub init_MUTEX_LOCKED {
        my($sem) = @_;
	    eval q({  &sema_init($sem, 0); });
    }' unless defined(&init_MUTEX_LOCKED);
    eval 'sub sem_getcount {
        my($sem) = @_;
	    eval q({  ($sem->{count}); });
    }' unless defined(&sem_getcount);
    eval 'sub down_interruptible {
        my($sem) = @_;
	    eval q({ \'int\'  &ret = 0;  &might_sleep();  &spin_lock_irq( ($sem->{sentry}));  &if ( ($sem->{count}) > 0) {  ($sem->{count})--; }  &else {  &ret =  &__down_interruptible($sem); }  &spin_unlock_irq( ($sem->{sentry}));  &ret; });
    }' unless defined(&down_interruptible);
}
1;
