require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PARISC_TLB_H)) {
    eval 'sub _PARISC_TLB_H () {1;}' unless defined(&_PARISC_TLB_H);
    eval 'sub tlb_flush {
        my($tlb) = @_;
	    eval q( &do {  &if (($tlb)-> &fullmm)  &flush_tlb_mm(($tlb)-> &mm);}  &while (0));
    }' unless defined(&tlb_flush);
    eval 'sub tlb_start_vma {
        my($tlb, $vma) = @_;
	    eval q( &do {  &if (!($tlb)-> &fullmm)  &flush_cache_range($vma,  ($vma->{vm_start}),  ($vma->{vm_end})); }  &while (0));
    }' unless defined(&tlb_start_vma);
    eval 'sub tlb_end_vma {
        my($tlb, $vma) = @_;
	    eval q( &do {  &if (!($tlb)-> &fullmm)  &flush_tlb_range($vma,  ($vma->{vm_start}),  ($vma->{vm_end})); }  &while (0));
    }' unless defined(&tlb_end_vma);
    eval 'sub __tlb_remove_tlb_entry {
        my($tlb, $pte, $address) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&__tlb_remove_tlb_entry);
    require 'asm-generic/tlb.ph';
    eval 'sub __pmd_free_tlb {
        my($tlb, $pmd) = @_;
	    eval q( &pmd_free($pmd));
    }' unless defined(&__pmd_free_tlb);
    eval 'sub __pte_free_tlb {
        my($tlb, $pte) = @_;
	    eval q( &pte_free($pte));
    }' unless defined(&__pte_free_tlb);
}
1;
