require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_FENV_H)) {
    die("Never use <bits/fenv.h> directly; include <fenv.h> instead.");
}
eval("sub FE_INVALID () { 1<<4; }") unless defined(&FE_INVALID);
eval("sub FE_DIVBYZERO () { 1<<3; }") unless defined(&FE_DIVBYZERO);
eval("sub FE_OVERFLOW () { 1<<2; }") unless defined(&FE_OVERFLOW);
eval("sub FE_UNDERFLOW () { 1<<1; }") unless defined(&FE_UNDERFLOW);
eval("sub FE_INEXACT () { 1<<0; }") unless defined(&FE_INEXACT);
unless(defined(&FE_ALL_EXCEPT)) {
    sub FE_ALL_EXCEPT () {	( &FE_INEXACT |  &FE_DIVBYZERO |  &FE_UNDERFLOW |  &FE_OVERFLOW |  &FE_INVALID);}
}
eval("sub FE_TONEAREST () { 0<<9; }") unless defined(&FE_TONEAREST);
eval("sub FE_TOWARDZERO () { 1<<9; }") unless defined(&FE_TOWARDZERO);
eval("sub FE_UPWARD () { 2<<9; }") unless defined(&FE_UPWARD);
eval("sub FE_DOWNWARD () { 3<<9; }") unless defined(&FE_DOWNWARD);
unless(defined(&FE_DFL_ENV)) {
    sub FE_DFL_ENV () {	(( &fenv_t *) -1);}
}
if(defined(&__USE_GNU)) {
    eval 'sub FE_NOMASK_ENV () {(( &fenv_t *) -2);}' unless defined(&FE_NOMASK_ENV);
}
1;
