require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_IF_PPP_H_)) {
    eval 'sub _IF_PPP_H_ () {1;}' unless defined(&_IF_PPP_H_);
    require 'linux/types.ph';
    require 'linux/ppp_defs.ph';
    require 'linux/if.ph';
    eval 'sub PPP_MTU () {1500;}' unless defined(&PPP_MTU);
    eval 'sub PPP_MAXMRU () {65000;}' unless defined(&PPP_MAXMRU);
    eval 'sub PROTO_IPX () {0x2b;}' unless defined(&PROTO_IPX);
    eval 'sub PROTO_DNA_RT () {0x27;}' unless defined(&PROTO_DNA_RT);
    eval 'sub SC_COMP_PROT () {0x1;}' unless defined(&SC_COMP_PROT);
    eval 'sub SC_COMP_AC () {0x2;}' unless defined(&SC_COMP_AC);
    eval 'sub SC_COMP_TCP () {0x4;}' unless defined(&SC_COMP_TCP);
    eval 'sub SC_NO_TCP_CCID () {0x8;}' unless defined(&SC_NO_TCP_CCID);
    eval 'sub SC_REJ_COMP_AC () {0x10;}' unless defined(&SC_REJ_COMP_AC);
    eval 'sub SC_REJ_COMP_TCP () {0x20;}' unless defined(&SC_REJ_COMP_TCP);
    eval 'sub SC_CCP_OPEN () {0x40;}' unless defined(&SC_CCP_OPEN);
    eval 'sub SC_CCP_UP () {0x80;}' unless defined(&SC_CCP_UP);
    eval 'sub SC_ENABLE_IP () {0x100;}' unless defined(&SC_ENABLE_IP);
    eval 'sub SC_LOOP_TRAFFIC () {0x200;}' unless defined(&SC_LOOP_TRAFFIC);
    eval 'sub SC_MULTILINK () {0x400;}' unless defined(&SC_MULTILINK);
    eval 'sub SC_MP_SHORTSEQ () {0x800;}' unless defined(&SC_MP_SHORTSEQ);
    eval 'sub SC_COMP_RUN () {0x1000;}' unless defined(&SC_COMP_RUN);
    eval 'sub SC_DECOMP_RUN () {0x2000;}' unless defined(&SC_DECOMP_RUN);
    eval 'sub SC_MP_XSHORTSEQ () {0x4000;}' unless defined(&SC_MP_XSHORTSEQ);
    eval 'sub SC_DEBUG () {0x10000;}' unless defined(&SC_DEBUG);
    eval 'sub SC_LOG_INPKT () {0x20000;}' unless defined(&SC_LOG_INPKT);
    eval 'sub SC_LOG_OUTPKT () {0x40000;}' unless defined(&SC_LOG_OUTPKT);
    eval 'sub SC_LOG_RAWIN () {0x80000;}' unless defined(&SC_LOG_RAWIN);
    eval 'sub SC_LOG_FLUSH () {0x100000;}' unless defined(&SC_LOG_FLUSH);
    eval 'sub SC_SYNC () {0x200000;}' unless defined(&SC_SYNC);
    eval 'sub SC_MASK () {0xf200fff;}' unless defined(&SC_MASK);
    eval 'sub SC_XMIT_BUSY () {0x10000000;}' unless defined(&SC_XMIT_BUSY);
    eval 'sub SC_RCV_ODDP () {0x8000000;}' unless defined(&SC_RCV_ODDP);
    eval 'sub SC_RCV_EVNP () {0x4000000;}' unless defined(&SC_RCV_EVNP);
    eval 'sub SC_RCV_B7_1 () {0x2000000;}' unless defined(&SC_RCV_B7_1);
    eval 'sub SC_RCV_B7_0 () {0x1000000;}' unless defined(&SC_RCV_B7_0);
    eval 'sub SC_DC_FERROR () {0x800000;}' unless defined(&SC_DC_FERROR);
    eval 'sub SC_DC_ERROR () {0x400000;}' unless defined(&SC_DC_ERROR);
    eval 'sub ifr__name () { ($b->{ifr_ifrn}->{ifrn_name});}' unless defined(&ifr__name);
    eval 'sub stats_ptr () { ($b->{ifr_ifru}->{ifru_data});}' unless defined(&stats_ptr);
    eval 'sub PPPIOCGFLAGS () { &_IOR(ord(\'t\'), 90, \'int\');}' unless defined(&PPPIOCGFLAGS);
    eval 'sub PPPIOCSFLAGS () { &_IOW(ord(\'t\'), 89, \'int\');}' unless defined(&PPPIOCSFLAGS);
    eval 'sub PPPIOCGASYNCMAP () { &_IOR(ord(\'t\'), 88, \'int\');}' unless defined(&PPPIOCGASYNCMAP);
    eval 'sub PPPIOCSASYNCMAP () { &_IOW(ord(\'t\'), 87, \'int\');}' unless defined(&PPPIOCSASYNCMAP);
    eval 'sub PPPIOCGUNIT () { &_IOR(ord(\'t\'), 86, \'int\');}' unless defined(&PPPIOCGUNIT);
    eval 'sub PPPIOCGRASYNCMAP () { &_IOR(ord(\'t\'), 85, \'int\');}' unless defined(&PPPIOCGRASYNCMAP);
    eval 'sub PPPIOCSRASYNCMAP () { &_IOW(ord(\'t\'), 84, \'int\');}' unless defined(&PPPIOCSRASYNCMAP);
    eval 'sub PPPIOCGMRU () { &_IOR(ord(\'t\'), 83, \'int\');}' unless defined(&PPPIOCGMRU);
    eval 'sub PPPIOCSMRU () { &_IOW(ord(\'t\'), 82, \'int\');}' unless defined(&PPPIOCSMRU);
    eval 'sub PPPIOCSMAXCID () { &_IOW(ord(\'t\'), 81, \'int\');}' unless defined(&PPPIOCSMAXCID);
    eval 'sub PPPIOCGXASYNCMAP () { &_IOR(ord(\'t\'), 80,  &ext_accm);}' unless defined(&PPPIOCGXASYNCMAP);
    eval 'sub PPPIOCSXASYNCMAP () { &_IOW(ord(\'t\'), 79,  &ext_accm);}' unless defined(&PPPIOCSXASYNCMAP);
    eval 'sub PPPIOCXFERUNIT () { &_IO(ord(\'t\'), 78);}' unless defined(&PPPIOCXFERUNIT);
    eval 'sub PPPIOCSCOMPRESS () { &_IOW(ord(\'t\'), 77, \'struct ppp_option_data\');}' unless defined(&PPPIOCSCOMPRESS);
    eval 'sub PPPIOCGNPMODE () { &_IOWR(ord(\'t\'), 76, \'struct npioctl\');}' unless defined(&PPPIOCGNPMODE);
    eval 'sub PPPIOCSNPMODE () { &_IOW(ord(\'t\'), 75, \'struct npioctl\');}' unless defined(&PPPIOCSNPMODE);
    eval 'sub PPPIOCSPASS () { &_IOW(ord(\'t\'), 71, \'struct sock_fprog\');}' unless defined(&PPPIOCSPASS);
    eval 'sub PPPIOCSACTIVE () { &_IOW(ord(\'t\'), 70, \'struct sock_fprog\');}' unless defined(&PPPIOCSACTIVE);
    eval 'sub PPPIOCGDEBUG () { &_IOR(ord(\'t\'), 65, \'int\');}' unless defined(&PPPIOCGDEBUG);
    eval 'sub PPPIOCSDEBUG () { &_IOW(ord(\'t\'), 64, \'int\');}' unless defined(&PPPIOCSDEBUG);
    eval 'sub PPPIOCGIDLE () { &_IOR(ord(\'t\'), 63, \'struct ppp_idle\');}' unless defined(&PPPIOCGIDLE);
    eval 'sub PPPIOCNEWUNIT () { &_IOWR(ord(\'t\'), 62, \'int\');}' unless defined(&PPPIOCNEWUNIT);
    eval 'sub PPPIOCATTACH () { &_IOW(ord(\'t\'), 61, \'int\');}' unless defined(&PPPIOCATTACH);
    eval 'sub PPPIOCDETACH () { &_IOW(ord(\'t\'), 60, \'int\');}' unless defined(&PPPIOCDETACH);
    eval 'sub PPPIOCSMRRU () { &_IOW(ord(\'t\'), 59, \'int\');}' unless defined(&PPPIOCSMRRU);
    eval 'sub PPPIOCCONNECT () { &_IOW(ord(\'t\'), 58, \'int\');}' unless defined(&PPPIOCCONNECT);
    eval 'sub PPPIOCDISCONN () { &_IO(ord(\'t\'), 57);}' unless defined(&PPPIOCDISCONN);
    eval 'sub PPPIOCATTCHAN () { &_IOW(ord(\'t\'), 56, \'int\');}' unless defined(&PPPIOCATTCHAN);
    eval 'sub PPPIOCGCHAN () { &_IOR(ord(\'t\'), 55, \'int\');}' unless defined(&PPPIOCGCHAN);
    eval 'sub SIOCGPPPSTATS () {( &SIOCDEVPRIVATE + 0);}' unless defined(&SIOCGPPPSTATS);
    eval 'sub SIOCGPPPVER () {( &SIOCDEVPRIVATE + 1);}' unless defined(&SIOCGPPPVER);
    eval 'sub SIOCGPPPCSTATS () {( &SIOCDEVPRIVATE + 2);}' unless defined(&SIOCGPPPCSTATS);
    if(!defined( &ifr_mtu)) {
	eval 'sub ifr_mtu () { ($ifr_ifru->{ifru_metric});}' unless defined(&ifr_mtu);
    }
}
1;
