require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ARPTABLES_H)) {
    eval 'sub _ARPTABLES_H () {1;}' unless defined(&_ARPTABLES_H);
    if(defined(&__KERNEL__)) {
	require 'linux/if.ph';
	require 'linux/types.ph';
	require 'linux/in.ph';
	require 'linux/if_arp.ph';
	require 'linux/skbuff.ph';
    }
    require 'linux/compiler.ph';
    require 'linux/netfilter_arp.ph';
    eval 'sub ARPT_FUNCTION_MAXNAMELEN () {30;}' unless defined(&ARPT_FUNCTION_MAXNAMELEN);
    eval 'sub ARPT_TABLE_MAXNAMELEN () {32;}' unless defined(&ARPT_TABLE_MAXNAMELEN);
    eval 'sub ARPT_DEV_ADDR_LEN_MAX () {16;}' unless defined(&ARPT_DEV_ADDR_LEN_MAX);
    eval 'sub ARPT_F_MASK () {0x;}' unless defined(&ARPT_F_MASK);
    eval 'sub ARPT_INV_VIA_IN () {0x1;}' unless defined(&ARPT_INV_VIA_IN);
    eval 'sub ARPT_INV_VIA_OUT () {0x2;}' unless defined(&ARPT_INV_VIA_OUT);
    eval 'sub ARPT_INV_SRCIP () {0x4;}' unless defined(&ARPT_INV_SRCIP);
    eval 'sub ARPT_INV_TGTIP () {0x8;}' unless defined(&ARPT_INV_TGTIP);
    eval 'sub ARPT_INV_SRCDEVADDR () {0x10;}' unless defined(&ARPT_INV_SRCDEVADDR);
    eval 'sub ARPT_INV_TGTDEVADDR () {0x20;}' unless defined(&ARPT_INV_TGTDEVADDR);
    eval 'sub ARPT_INV_ARPOP () {0x40;}' unless defined(&ARPT_INV_ARPOP);
    eval 'sub ARPT_INV_ARPHRD () {0x80;}' unless defined(&ARPT_INV_ARPHRD);
    eval 'sub ARPT_INV_ARPPRO () {0x100;}' unless defined(&ARPT_INV_ARPPRO);
    eval 'sub ARPT_INV_ARPHLN () {0x200;}' unless defined(&ARPT_INV_ARPHLN);
    eval 'sub ARPT_INV_MASK () {0x3ff;}' unless defined(&ARPT_INV_MASK);
    eval 'sub ARPT_BASE_CTL () {96;}' unless defined(&ARPT_BASE_CTL);
    eval 'sub ARPT_SO_SET_REPLACE () {( &ARPT_BASE_CTL);}' unless defined(&ARPT_SO_SET_REPLACE);
    eval 'sub ARPT_SO_SET_ADD_COUNTERS () {( &ARPT_BASE_CTL + 1);}' unless defined(&ARPT_SO_SET_ADD_COUNTERS);
    eval 'sub ARPT_SO_SET_MAX () { &ARPT_SO_SET_ADD_COUNTERS;}' unless defined(&ARPT_SO_SET_MAX);
    eval 'sub ARPT_SO_GET_INFO () {( &ARPT_BASE_CTL);}' unless defined(&ARPT_SO_GET_INFO);
    eval 'sub ARPT_SO_GET_ENTRIES () {( &ARPT_BASE_CTL + 1);}' unless defined(&ARPT_SO_GET_ENTRIES);
    eval 'sub ARPT_SO_GET_MAX () { &ARPT_SO_GET_ENTRIES;}' unless defined(&ARPT_SO_GET_MAX);
    eval 'sub ARPT_CONTINUE () {0xffffffff;}' unless defined(&ARPT_CONTINUE);
    eval 'sub ARPT_RETURN () {(- &NF_MAX_VERDICT - 1);}' unless defined(&ARPT_RETURN);
    eval 'sub ARPT_STANDARD_TARGET () {"";}' unless defined(&ARPT_STANDARD_TARGET);
    eval 'sub ARPT_ERROR_TARGET () {"ERROR";}' unless defined(&ARPT_ERROR_TARGET);
    eval 'sub ARPT_ENTRY_ITERATE () {( &entries,  &size,  &fn,  &args...) ({ \'unsigned int __i\'; \'int\'  &__ret = 0; \'struct arpt_entry\' * &__entry;  &for ( &__i = 0;  &__i < ( &size);  &__i +=  ($__entry->{next_offset})) {  &__entry = ( &void *)( &entries) +  &__i;  &__ret =  &fn( &__entry ,   &args);  &if ( &__ret != 0)  &break; }  &__ret; });}' unless defined(&ARPT_ENTRY_ITERATE);
    if(defined(&__KERNEL__)) {
	eval 'sub ARPT_ALIGN {
	    my($s) = @_;
    	    eval q(((($s) + ( &__alignof__-1)) & ~( &__alignof__-1)));
	}' unless defined(&ARPT_ALIGN);
    }
}
1;
