require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&NFSD_EXPORT_H)) {
    eval 'sub NFSD_EXPORT_H () {1;}' unless defined(&NFSD_EXPORT_H);
    require 'asm/types.ph';
    if(defined(&__KERNEL__)) {
	require 'linux/types.ph';
	require 'linux/in.ph';
    }
    eval 'sub NFSCLNT_IDMAX () {1024;}' unless defined(&NFSCLNT_IDMAX);
    eval 'sub NFSCLNT_ADDRMAX () {16;}' unless defined(&NFSCLNT_ADDRMAX);
    eval 'sub NFSCLNT_KEYMAX () {32;}' unless defined(&NFSCLNT_KEYMAX);
    eval 'sub NFSEXP_READONLY () {0x1;}' unless defined(&NFSEXP_READONLY);
    eval 'sub NFSEXP_INSECURE_PORT () {0x2;}' unless defined(&NFSEXP_INSECURE_PORT);
    eval 'sub NFSEXP_ROOTSQUASH () {0x4;}' unless defined(&NFSEXP_ROOTSQUASH);
    eval 'sub NFSEXP_ALLSQUASH () {0x8;}' unless defined(&NFSEXP_ALLSQUASH);
    eval 'sub NFSEXP_ASYNC () {0x10;}' unless defined(&NFSEXP_ASYNC);
    eval 'sub NFSEXP_GATHERED_WRITES () {0x20;}' unless defined(&NFSEXP_GATHERED_WRITES);
    eval 'sub NFSEXP_NOHIDE () {0x200;}' unless defined(&NFSEXP_NOHIDE);
    eval 'sub NFSEXP_NOSUBTREECHECK () {0x400;}' unless defined(&NFSEXP_NOSUBTREECHECK);
    eval 'sub NFSEXP_NOAUTHNLM () {0x800;}' unless defined(&NFSEXP_NOAUTHNLM);
    eval 'sub NFSEXP_MSNFS () {0x1000;}' unless defined(&NFSEXP_MSNFS);
    eval 'sub NFSEXP_FSID () {0x2000;}' unless defined(&NFSEXP_FSID);
    eval 'sub NFSEXP_CROSSMOUNT () {0x4000;}' unless defined(&NFSEXP_CROSSMOUNT);
    eval 'sub NFSEXP_NOACL () {0x8000;}' unless defined(&NFSEXP_NOACL);
    eval 'sub NFSEXP_ALLFLAGS () {0xfe3f;}' unless defined(&NFSEXP_ALLFLAGS);
    if(defined(&__KERNEL__)) {
	eval 'sub EX_SECURE {
	    my($exp) = @_;
    	    eval q((!(($exp)-> &ex_flags &  &NFSEXP_INSECURE_PORT)));
	}' unless defined(&EX_SECURE);
	eval 'sub EX_ISSYNC {
	    my($exp) = @_;
    	    eval q((!(($exp)-> &ex_flags &  &NFSEXP_ASYNC)));
	}' unless defined(&EX_ISSYNC);
	eval 'sub EX_RDONLY {
	    my($exp) = @_;
    	    eval q((($exp)-> &ex_flags &  &NFSEXP_READONLY));
	}' unless defined(&EX_RDONLY);
	eval 'sub EX_NOHIDE {
	    my($exp) = @_;
    	    eval q((($exp)-> &ex_flags &  &NFSEXP_NOHIDE));
	}' unless defined(&EX_NOHIDE);
	eval 'sub EX_WGATHER {
	    my($exp) = @_;
    	    eval q((($exp)-> &ex_flags &  &NFSEXP_GATHERED_WRITES));
	}' unless defined(&EX_WGATHER);
	eval 'sub exp_put {
	    my($exp) = @_;
    	    eval q({  &svc_export_put( ($exp->{h}),  &svc_export_cache); });
	}' unless defined(&exp_put);
	eval 'sub exp_get {
	    my($exp) = @_;
    	    eval q({  &cache_get( ($exp->{h})); });
	}' unless defined(&exp_get);
	eval 'sub exp_find {
	    my($clp,$fsid_type,$fsidv,$reqp) = @_;
    	    eval q({ \'struct svc_expkey\' * &ek =  &exp_find_key($clp, $fsid_type, $fsidv, $reqp);  &if ( &ek  && ! &IS_ERR( &ek)) { \'struct svc_export\' * &exp =  ($ek->{ek_export}); \'int\'  &err;  &exp_get( &exp);  &expkey_put( ($ek->{h}),  &svc_expkey_cache);  &if (( &err =  &cache_check( &svc_export_cache,  ($exp->{h}), $reqp)))  &exp =  &ERR_PTR( &err);  &exp; }  &else  &ERR_PTR( &PTR_ERR( &ek)); });
	}' unless defined(&exp_find);
    }
}
1;
