require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PTHREAD_H)) {
    eval 'sub _PTHREAD_H () {1;}' unless defined(&_PTHREAD_H);
    require 'features.ph';
    require 'sched.ph';
    require 'time.ph';
    eval 'sub __need_sigset_t () {1;}' unless defined(&__need_sigset_t);
    require 'signal.ph';
    require 'bits/pthreadtypes.ph';
    require 'bits/initspin.ph';
    eval 'sub PTHREAD_MUTEX_INITIALIZER () {{0, 0, 0,  &PTHREAD_MUTEX_TIMED_NP,  &__LOCK_ALT_INITIALIZER};}' unless defined(&PTHREAD_MUTEX_INITIALIZER);
    if(defined(&__USE_GNU)) {
	eval 'sub PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP () {{0, 0, 0,  &PTHREAD_MUTEX_RECURSIVE_NP,  &__LOCK_ALT_INITIALIZER};}' unless defined(&PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP);
	eval 'sub PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP () {{0, 0, 0,  &PTHREAD_MUTEX_ERRORCHECK_NP,  &__LOCK_ALT_INITIALIZER};}' unless defined(&PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP);
	eval 'sub PTHREAD_ADAPTIVE_MUTEX_INITIALIZER_NP () {{0, 0, 0,  &PTHREAD_MUTEX_ADAPTIVE_NP,  &__LOCK_ALT_INITIALIZER};}' unless defined(&PTHREAD_ADAPTIVE_MUTEX_INITIALIZER_NP);
    }
    eval 'sub PTHREAD_COND_INITIALIZER () {{ &__LOCK_ALT_INITIALIZER, 0, "", 0};}' unless defined(&PTHREAD_COND_INITIALIZER);
    if(defined (defined(&__USE_UNIX98) ? &__USE_UNIX98 : 0) || defined (defined(&__USE_XOPEN2K) ? &__USE_XOPEN2K : 0)) {
	eval 'sub PTHREAD_RWLOCK_INITIALIZER () {{  &__LOCK_ALT_INITIALIZER, 0,  &NULL,  &NULL,  &NULL,  &PTHREAD_RWLOCK_DEFAULT_NP,  &PTHREAD_PROCESS_PRIVATE };}' unless defined(&PTHREAD_RWLOCK_INITIALIZER);
    }
    if(defined(&__USE_GNU)) {
	eval 'sub PTHREAD_RWLOCK_WRITER_NONRECURSIVE_INITIALIZER_NP () {{  &__LOCK_ALT_INITIALIZER, 0,  &NULL,  &NULL,  &NULL,  &PTHREAD_RWLOCK_PREFER_WRITER_NONRECURSIVE_NP,  &PTHREAD_PROCESS_PRIVATE };}' unless defined(&PTHREAD_RWLOCK_WRITER_NONRECURSIVE_INITIALIZER_NP);
    }
    eval("sub PTHREAD_CREATE_JOINABLE () { 0; }") unless defined(&PTHREAD_CREATE_JOINABLE);
    eval("sub PTHREAD_CREATE_DETACHED () { 1; }") unless defined(&PTHREAD_CREATE_DETACHED);
    eval("sub PTHREAD_INHERIT_SCHED () { 0; }") unless defined(&PTHREAD_INHERIT_SCHED);
    eval("sub PTHREAD_EXPLICIT_SCHED () { 1; }") unless defined(&PTHREAD_EXPLICIT_SCHED);
    eval("sub PTHREAD_SCOPE_SYSTEM () { 0; }") unless defined(&PTHREAD_SCOPE_SYSTEM);
    eval("sub PTHREAD_SCOPE_PROCESS () { 1; }") unless defined(&PTHREAD_SCOPE_PROCESS);
    eval("sub PTHREAD_MUTEX_TIMED_NP () { 0; }") unless defined(&PTHREAD_MUTEX_TIMED_NP);
    eval("sub PTHREAD_MUTEX_RECURSIVE_NP () { 1; }") unless defined(&PTHREAD_MUTEX_RECURSIVE_NP);
    eval("sub PTHREAD_MUTEX_ERRORCHECK_NP () { 2; }") unless defined(&PTHREAD_MUTEX_ERRORCHECK_NP);
    eval("sub PTHREAD_MUTEX_ADAPTIVE_NP () { 3; }") unless defined(&PTHREAD_MUTEX_ADAPTIVE_NP);
    eval("sub PTHREAD_PROCESS_PRIVATE () { 0; }") unless defined(&PTHREAD_PROCESS_PRIVATE);
    eval("sub PTHREAD_PROCESS_SHARED () { 1; }") unless defined(&PTHREAD_PROCESS_SHARED);
    if(defined (defined(&__USE_UNIX98) ? &__USE_UNIX98 : 0) || defined (defined(&__USE_XOPEN2K) ? &__USE_XOPEN2K : 0)) {
	eval("sub PTHREAD_RWLOCK_PREFER_READER_NP () { 0; }") unless defined(&PTHREAD_RWLOCK_PREFER_READER_NP);
	eval("sub PTHREAD_RWLOCK_PREFER_WRITER_NP () { 1; }") unless defined(&PTHREAD_RWLOCK_PREFER_WRITER_NP);
	eval("sub PTHREAD_RWLOCK_PREFER_WRITER_NONRECURSIVE_NP () { 2; }") unless defined(&PTHREAD_RWLOCK_PREFER_WRITER_NONRECURSIVE_NP);
	eval("sub PTHREAD_RWLOCK_DEFAULT_NP () { PTHREAD_RWLOCK_PREFER_WRITER_NP; }") unless defined(&PTHREAD_RWLOCK_DEFAULT_NP);
    }
    eval 'sub PTHREAD_ONCE_INIT () {0;}' unless defined(&PTHREAD_ONCE_INIT);
    if(defined(&__USE_XOPEN2K)) {
	eval 'sub PTHREAD_BARRIER_SERIAL_THREAD () {-1;}' unless defined(&PTHREAD_BARRIER_SERIAL_THREAD);
    }
    eval("sub PTHREAD_CANCEL_ENABLE () { 0; }") unless defined(&PTHREAD_CANCEL_ENABLE);
    eval("sub PTHREAD_CANCEL_DISABLE () { 1; }") unless defined(&PTHREAD_CANCEL_DISABLE);
    eval("sub PTHREAD_CANCEL_DEFERRED () { 0; }") unless defined(&PTHREAD_CANCEL_DEFERRED);
    eval("sub PTHREAD_CANCEL_ASYNCHRONOUS () { 1; }") unless defined(&PTHREAD_CANCEL_ASYNCHRONOUS);
    eval 'sub PTHREAD_CANCELED () {(( &void *) -1);}' unless defined(&PTHREAD_CANCELED);
    if(defined(&__USE_UNIX98)) {
    }
    if(defined(&__USE_XOPEN2K)) {
    }
    if(defined(&__USE_GNU)) {
    }
    if(defined(&__USE_UNIX98)) {
    }
    if(defined(&__USE_GNU)) {
    }
    if(defined(&__USE_XOPEN2K)) {
    }
    if(defined(&__USE_UNIX98)) {
    }
    if(defined (defined(&__USE_UNIX98) ? &__USE_UNIX98 : 0) || defined (defined(&__USE_XOPEN2K) ? &__USE_XOPEN2K : 0)) {
	if(defined(&__USE_XOPEN2K)) {
	}
	if(defined(&__USE_XOPEN2K)) {
	}
    }
    if(defined(&__USE_XOPEN2K)) {
    }
    eval 'sub pthread_cleanup_push {
        my($routine,$arg) = @_;
	    eval q({ \'struct _pthread_cleanup_buffer\'  &_buffer;  &_pthread_cleanup_push (& &_buffer, ($routine), ($arg)););
    }' unless defined(&pthread_cleanup_push);
    eval 'sub pthread_cleanup_pop {
        my($execute) = @_;
	    eval q( &_pthread_cleanup_pop (& &_buffer, ($execute)); });
    }' unless defined(&pthread_cleanup_pop);
    if(defined(&__USE_GNU)) {
	eval 'sub pthread_cleanup_push_defer_np {
	    my($routine,$arg) = @_;
    	    eval q({ \'struct _pthread_cleanup_buffer\'  &_buffer;  &_pthread_cleanup_push_defer (& &_buffer, ($routine), ($arg)););
	}' unless defined(&pthread_cleanup_push_defer_np);
	eval 'sub pthread_cleanup_pop_restore_np {
	    my($execute) = @_;
    	    eval q( &_pthread_cleanup_pop_restore (& &_buffer, ($execute)); });
	}' unless defined(&pthread_cleanup_pop_restore_np);
    }
    if(defined(&__USE_XOPEN2K)) {
    }
    require 'bits/sigthread.ph';
}
1;
