require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PARISC_DELAY_H)) {
    eval 'sub _PARISC_DELAY_H () {1;}' unless defined(&_PARISC_DELAY_H);
    require 'asm/system.ph';
    require 'asm/processor.ph';
    eval 'sub __cr16_delay {
        my($clocks) = @_;
	    eval q({ my $start;  $start =  &mfctl(16);  &while (( &mfctl(16) -  $start) < $clocks) ; });
    }' unless defined(&__cr16_delay);
    eval 'sub __udelay {
        my($usecs) = @_;
	    eval q({  &__cr16_delay($usecs * ( ($boot_cpu_data->{cpu_hz}) / 1000000)); });
    }' unless defined(&__udelay);
    eval 'sub udelay {
        my($n) = @_;
	    eval q( &__udelay($n));
    }' unless defined(&udelay);
}
1;
