require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_DMA_H)) {
    eval 'sub _ASM_DMA_H () {1;}' unless defined(&_ASM_DMA_H);
    require 'linux/config.ph';
    require 'asm/io.ph';
    require 'asm/system.ph';
    eval 'sub dma_outb () { &outb;}' unless defined(&dma_outb);
    eval 'sub dma_inb () { &inb;}' unless defined(&dma_inb);
    eval 'sub DMA_CHUNK_SIZE () {( &BITS_PER_LONG* &PAGE_SIZE);}' unless defined(&DMA_CHUNK_SIZE);
    eval 'sub MAX_DMA_ADDRESS () {(~0);}' unless defined(&MAX_DMA_ADDRESS);
    eval 'sub MAX_DMA_CHANNELS () {8;}' unless defined(&MAX_DMA_CHANNELS);
    eval 'sub DMA_MODE_READ () {1;}' unless defined(&DMA_MODE_READ);
    eval 'sub DMA_MODE_WRITE () {2;}' unless defined(&DMA_MODE_WRITE);
    eval 'sub DMA_AUTOINIT () {0x10;}' unless defined(&DMA_AUTOINIT);
    eval 'sub IO_DMA1_BASE () {0x;}' unless defined(&IO_DMA1_BASE);
    eval 'sub IO_DMA2_BASE () {0xc0;}' unless defined(&IO_DMA2_BASE);
    eval 'sub DMA1_CMD_REG () {0x8;}' unless defined(&DMA1_CMD_REG);
    eval 'sub DMA1_STAT_REG () {0x8;}' unless defined(&DMA1_STAT_REG);
    eval 'sub DMA1_REQ_REG () {0x9;}' unless defined(&DMA1_REQ_REG);
    eval 'sub DMA1_MASK_REG () {0xa;}' unless defined(&DMA1_MASK_REG);
    eval 'sub DMA1_MODE_REG () {0xb;}' unless defined(&DMA1_MODE_REG);
    eval 'sub DMA1_CLEAR_FF_REG () {0xc;}' unless defined(&DMA1_CLEAR_FF_REG);
    eval 'sub DMA1_TEMP_REG () {0xd;}' unless defined(&DMA1_TEMP_REG);
    eval 'sub DMA1_RESET_REG () {0xd;}' unless defined(&DMA1_RESET_REG);
    eval 'sub DMA1_CLR_MASK_REG () {0xe;}' unless defined(&DMA1_CLR_MASK_REG);
    eval 'sub DMA1_MASK_ALL_REG () {0xf;}' unless defined(&DMA1_MASK_ALL_REG);
    eval 'sub DMA1_EXT_MODE_REG () {(0x400 |  &DMA1_MODE_REG);}' unless defined(&DMA1_EXT_MODE_REG);
    eval 'sub DMA2_CMD_REG () {0xd0;}' unless defined(&DMA2_CMD_REG);
    eval 'sub DMA2_STAT_REG () {0xd0;}' unless defined(&DMA2_STAT_REG);
    eval 'sub DMA2_REQ_REG () {0xd2;}' unless defined(&DMA2_REQ_REG);
    eval 'sub DMA2_MASK_REG () {0xd4;}' unless defined(&DMA2_MASK_REG);
    eval 'sub DMA2_MODE_REG () {0xd6;}' unless defined(&DMA2_MODE_REG);
    eval 'sub DMA2_CLEAR_FF_REG () {0xd8;}' unless defined(&DMA2_CLEAR_FF_REG);
    eval 'sub DMA2_TEMP_REG () {0xda;}' unless defined(&DMA2_TEMP_REG);
    eval 'sub DMA2_RESET_REG () {0xda;}' unless defined(&DMA2_RESET_REG);
    eval 'sub DMA2_CLR_MASK_REG () {0xdc;}' unless defined(&DMA2_CLR_MASK_REG);
    eval 'sub DMA2_MASK_ALL_REG () {0xde;}' unless defined(&DMA2_MASK_ALL_REG);
    eval 'sub DMA2_EXT_MODE_REG () {(0x400 |  &DMA2_MODE_REG);}' unless defined(&DMA2_EXT_MODE_REG);
    eval 'sub claim_dma_lock {
        my($void) = @_;
	    eval q({ my $flags;  &spin_lock_irqsave( &dma_spin_lock,  $flags);  $flags; });
    }' unless defined(&claim_dma_lock);
    eval 'sub release_dma_lock {
        my($flags) = @_;
	    eval q({  &spin_unlock_irqrestore( &dma_spin_lock, $flags); });
    }' unless defined(&release_dma_lock);
    if(defined(&CONFIG_SUPERIO)) {
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub disable_dma {
        my($dmanr) = @_;
	    eval q({ });
    }' unless defined(&disable_dma);
    eval 'sub request_dma {
        my($dmanr, $device_id) = @_;
	    eval q((0));
    }' unless defined(&request_dma);
    eval 'sub free_dma {
        my($dmanr) = @_;
	    eval q();
    }' unless defined(&free_dma);
    if(defined(&CONFIG_PCI)) {
    } else {
	eval 'sub isa_dma_bridge_buggy () {(0);}' unless defined(&isa_dma_bridge_buggy);
    }
}
1;
