require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PARISC_ERRNO_H)) {
    eval 'sub _PARISC_ERRNO_H () {1;}' unless defined(&_PARISC_ERRNO_H);
    require 'asm-generic/errno-base.ph';
    eval 'sub ENOMSG () {35;}' unless defined(&ENOMSG);
    eval 'sub EIDRM () {36;}' unless defined(&EIDRM);
    eval 'sub ECHRNG () {37;}' unless defined(&ECHRNG);
    eval 'sub EL2NSYNC () {38;}' unless defined(&EL2NSYNC);
    eval 'sub EL3HLT () {39;}' unless defined(&EL3HLT);
    eval 'sub EL3RST () {40;}' unless defined(&EL3RST);
    eval 'sub ELNRNG () {41;}' unless defined(&ELNRNG);
    eval 'sub EUNATCH () {42;}' unless defined(&EUNATCH);
    eval 'sub ENOCSI () {43;}' unless defined(&ENOCSI);
    eval 'sub EL2HLT () {44;}' unless defined(&EL2HLT);
    eval 'sub EDEADLK () {45;}' unless defined(&EDEADLK);
    eval 'sub EDEADLOCK () { &EDEADLK;}' unless defined(&EDEADLOCK);
    eval 'sub ENOLCK () {46;}' unless defined(&ENOLCK);
    eval 'sub EILSEQ () {47;}' unless defined(&EILSEQ);
    eval 'sub ENONET () {50;}' unless defined(&ENONET);
    eval 'sub ENODATA () {51;}' unless defined(&ENODATA);
    eval 'sub ETIME () {52;}' unless defined(&ETIME);
    eval 'sub ENOSR () {53;}' unless defined(&ENOSR);
    eval 'sub ENOSTR () {54;}' unless defined(&ENOSTR);
    eval 'sub ENOPKG () {55;}' unless defined(&ENOPKG);
    eval 'sub ENOLINK () {57;}' unless defined(&ENOLINK);
    eval 'sub EADV () {58;}' unless defined(&EADV);
    eval 'sub ESRMNT () {59;}' unless defined(&ESRMNT);
    eval 'sub ECOMM () {60;}' unless defined(&ECOMM);
    eval 'sub EPROTO () {61;}' unless defined(&EPROTO);
    eval 'sub EMULTIHOP () {64;}' unless defined(&EMULTIHOP);
    eval 'sub EDOTDOT () {66;}' unless defined(&EDOTDOT);
    eval 'sub EBADMSG () {67;}' unless defined(&EBADMSG);
    eval 'sub EUSERS () {68;}' unless defined(&EUSERS);
    eval 'sub EDQUOT () {69;}' unless defined(&EDQUOT);
    eval 'sub ESTALE () {70;}' unless defined(&ESTALE);
    eval 'sub EREMOTE () {71;}' unless defined(&EREMOTE);
    eval 'sub EOVERFLOW () {72;}' unless defined(&EOVERFLOW);
    eval 'sub EBADE () {160;}' unless defined(&EBADE);
    eval 'sub EBADR () {161;}' unless defined(&EBADR);
    eval 'sub EXFULL () {162;}' unless defined(&EXFULL);
    eval 'sub ENOANO () {163;}' unless defined(&ENOANO);
    eval 'sub EBADRQC () {164;}' unless defined(&EBADRQC);
    eval 'sub EBADSLT () {165;}' unless defined(&EBADSLT);
    eval 'sub EBFONT () {166;}' unless defined(&EBFONT);
    eval 'sub ENOTUNIQ () {167;}' unless defined(&ENOTUNIQ);
    eval 'sub EBADFD () {168;}' unless defined(&EBADFD);
    eval 'sub EREMCHG () {169;}' unless defined(&EREMCHG);
    eval 'sub ELIBACC () {170;}' unless defined(&ELIBACC);
    eval 'sub ELIBBAD () {171;}' unless defined(&ELIBBAD);
    eval 'sub ELIBSCN () {172;}' unless defined(&ELIBSCN);
    eval 'sub ELIBMAX () {173;}' unless defined(&ELIBMAX);
    eval 'sub ELIBEXEC () {174;}' unless defined(&ELIBEXEC);
    eval 'sub ERESTART () {175;}' unless defined(&ERESTART);
    eval 'sub ESTRPIPE () {176;}' unless defined(&ESTRPIPE);
    eval 'sub EUCLEAN () {177;}' unless defined(&EUCLEAN);
    eval 'sub ENOTNAM () {178;}' unless defined(&ENOTNAM);
    eval 'sub ENAVAIL () {179;}' unless defined(&ENAVAIL);
    eval 'sub EISNAM () {180;}' unless defined(&EISNAM);
    eval 'sub EREMOTEIO () {181;}' unless defined(&EREMOTEIO);
    eval 'sub ENOMEDIUM () {182;}' unless defined(&ENOMEDIUM);
    eval 'sub EMEDIUMTYPE () {183;}' unless defined(&EMEDIUMTYPE);
    eval 'sub ENOKEY () {184;}' unless defined(&ENOKEY);
    eval 'sub EKEYEXPIRED () {185;}' unless defined(&EKEYEXPIRED);
    eval 'sub EKEYREVOKED () {186;}' unless defined(&EKEYREVOKED);
    eval 'sub EKEYREJECTED () {187;}' unless defined(&EKEYREJECTED);
    eval 'sub ENOSYM () {215;}' unless defined(&ENOSYM);
    eval 'sub ENOTSOCK () {216;}' unless defined(&ENOTSOCK);
    eval 'sub EDESTADDRREQ () {217;}' unless defined(&EDESTADDRREQ);
    eval 'sub EMSGSIZE () {218;}' unless defined(&EMSGSIZE);
    eval 'sub EPROTOTYPE () {219;}' unless defined(&EPROTOTYPE);
    eval 'sub ENOPROTOOPT () {220;}' unless defined(&ENOPROTOOPT);
    eval 'sub EPROTONOSUPPORT () {221;}' unless defined(&EPROTONOSUPPORT);
    eval 'sub ESOCKTNOSUPPORT () {222;}' unless defined(&ESOCKTNOSUPPORT);
    eval 'sub EOPNOTSUPP () {223;}' unless defined(&EOPNOTSUPP);
    eval 'sub EPFNOSUPPORT () {224;}' unless defined(&EPFNOSUPPORT);
    eval 'sub EAFNOSUPPORT () {225;}' unless defined(&EAFNOSUPPORT);
    eval 'sub EADDRINUSE () {226;}' unless defined(&EADDRINUSE);
    eval 'sub EADDRNOTAVAIL () {227;}' unless defined(&EADDRNOTAVAIL);
    eval 'sub ENETDOWN () {228;}' unless defined(&ENETDOWN);
    eval 'sub ENETUNREACH () {229;}' unless defined(&ENETUNREACH);
    eval 'sub ENETRESET () {230;}' unless defined(&ENETRESET);
    eval 'sub ECONNABORTED () {231;}' unless defined(&ECONNABORTED);
    eval 'sub ECONNRESET () {232;}' unless defined(&ECONNRESET);
    eval 'sub ENOBUFS () {233;}' unless defined(&ENOBUFS);
    eval 'sub EISCONN () {234;}' unless defined(&EISCONN);
    eval 'sub ENOTCONN () {235;}' unless defined(&ENOTCONN);
    eval 'sub ESHUTDOWN () {236;}' unless defined(&ESHUTDOWN);
    eval 'sub ETOOMANYREFS () {237;}' unless defined(&ETOOMANYREFS);
    eval 'sub EREFUSED () { &ECONNREFUSED;}' unless defined(&EREFUSED);
    eval 'sub ETIMEDOUT () {238;}' unless defined(&ETIMEDOUT);
    eval 'sub ECONNREFUSED () {239;}' unless defined(&ECONNREFUSED);
    eval 'sub EREMOTERELEASE () {240;}' unless defined(&EREMOTERELEASE);
    eval 'sub EHOSTDOWN () {241;}' unless defined(&EHOSTDOWN);
    eval 'sub EHOSTUNREACH () {242;}' unless defined(&EHOSTUNREACH);
    eval 'sub EALREADY () {244;}' unless defined(&EALREADY);
    eval 'sub EINPROGRESS () {245;}' unless defined(&EINPROGRESS);
    eval 'sub EWOULDBLOCK () {246;}' unless defined(&EWOULDBLOCK);
    eval 'sub ENOTEMPTY () {247;}' unless defined(&ENOTEMPTY);
    eval 'sub ENAMETOOLONG () {248;}' unless defined(&ENAMETOOLONG);
    eval 'sub ELOOP () {249;}' unless defined(&ELOOP);
    eval 'sub ENOSYS () {251;}' unless defined(&ENOSYS);
    eval 'sub ENOTSUP () {252;}' unless defined(&ENOTSUP);
    eval 'sub ECANCELLED () {253;}' unless defined(&ECANCELLED);
}
1;
