require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PARISC_FCNTL_H)) {
    eval 'sub _PARISC_FCNTL_H () {1;}' unless defined(&_PARISC_FCNTL_H);
    eval 'sub O_ACCMODE () {00000003;}' unless defined(&O_ACCMODE);
    eval 'sub O_RDONLY () {00000000;}' unless defined(&O_RDONLY);
    eval 'sub O_WRONLY () {00000001;}' unless defined(&O_WRONLY);
    eval 'sub O_RDWR () {00000002;}' unless defined(&O_RDWR);
    eval 'sub O_APPEND () {00000010;}' unless defined(&O_APPEND);
    eval 'sub O_BLKSEEK () {00000100;}' unless defined(&O_BLKSEEK);
    eval 'sub O_CREAT () {00000400;}' unless defined(&O_CREAT);
    eval 'sub O_TRUNC () {00001000;}' unless defined(&O_TRUNC);
    eval 'sub O_EXCL () {00002000;}' unless defined(&O_EXCL);
    eval 'sub O_LARGEFILE () {00004000;}' unless defined(&O_LARGEFILE);
    eval 'sub O_SYNC () {00100000;}' unless defined(&O_SYNC);
    eval 'sub O_NONBLOCK () {00200004;}' unless defined(&O_NONBLOCK);
    eval 'sub O_NDELAY () { &O_NONBLOCK;}' unless defined(&O_NDELAY);
    eval 'sub O_NOCTTY () {00400000;}' unless defined(&O_NOCTTY);
    eval 'sub O_DSYNC () {01000000;}' unless defined(&O_DSYNC);
    eval 'sub O_RSYNC () {02000000;}' unless defined(&O_RSYNC);
    eval 'sub O_NOATIME () {04000000;}' unless defined(&O_NOATIME);
    eval 'sub FASYNC () {00020000;}' unless defined(&FASYNC);
    eval 'sub O_DIRECT () {00040000;}' unless defined(&O_DIRECT);
    eval 'sub O_DIRECTORY () {00010000;}' unless defined(&O_DIRECTORY);
    eval 'sub O_NOFOLLOW () {00000200;}' unless defined(&O_NOFOLLOW);
    eval 'sub O_INVISIBLE () {04000000;}' unless defined(&O_INVISIBLE);
    eval 'sub F_DUPFD () {0;}' unless defined(&F_DUPFD);
    eval 'sub F_GETFD () {1;}' unless defined(&F_GETFD);
    eval 'sub F_SETFD () {2;}' unless defined(&F_SETFD);
    eval 'sub F_GETFL () {3;}' unless defined(&F_GETFL);
    eval 'sub F_SETFL () {4;}' unless defined(&F_SETFL);
    eval 'sub F_GETLK () {5;}' unless defined(&F_GETLK);
    eval 'sub F_SETLK () {6;}' unless defined(&F_SETLK);
    eval 'sub F_SETLKW () {7;}' unless defined(&F_SETLKW);
    eval 'sub F_GETLK64 () {8;}' unless defined(&F_GETLK64);
    eval 'sub F_SETLK64 () {9;}' unless defined(&F_SETLK64);
    eval 'sub F_SETLKW64 () {10;}' unless defined(&F_SETLKW64);
    eval 'sub F_GETOWN () {11;}' unless defined(&F_GETOWN);
    eval 'sub F_SETOWN () {12;}' unless defined(&F_SETOWN);
    eval 'sub F_SETSIG () {13;}' unless defined(&F_SETSIG);
    eval 'sub F_GETSIG () {14;}' unless defined(&F_GETSIG);
    eval 'sub FD_CLOEXEC () {1;}' unless defined(&FD_CLOEXEC);
    eval 'sub F_RDLCK () {01;}' unless defined(&F_RDLCK);
    eval 'sub F_WRLCK () {02;}' unless defined(&F_WRLCK);
    eval 'sub F_UNLCK () {03;}' unless defined(&F_UNLCK);
    eval 'sub F_EXLCK () {4;}' unless defined(&F_EXLCK);
    eval 'sub F_SHLCK () {8;}' unless defined(&F_SHLCK);
    eval 'sub F_INPROGRESS () {16;}' unless defined(&F_INPROGRESS);
    eval 'sub LOCK_SH () {1;}' unless defined(&LOCK_SH);
    eval 'sub LOCK_EX () {2;}' unless defined(&LOCK_EX);
    eval 'sub LOCK_NB () {4;}' unless defined(&LOCK_NB);
    eval 'sub LOCK_UN () {8;}' unless defined(&LOCK_UN);
    eval 'sub LOCK_MAND () {32;}' unless defined(&LOCK_MAND);
    eval 'sub LOCK_READ () {64;}' unless defined(&LOCK_READ);
    eval 'sub LOCK_WRITE () {128;}' unless defined(&LOCK_WRITE);
    eval 'sub LOCK_RW () {192;}' unless defined(&LOCK_RW);
    eval 'sub F_LINUX_SPECIFIC_BASE () {1024;}' unless defined(&F_LINUX_SPECIFIC_BASE);
}
1;
