require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ARCH_PARISC_IOCTLS_H__)) {
    eval 'sub __ARCH_PARISC_IOCTLS_H__ () {1;}' unless defined(&__ARCH_PARISC_IOCTLS_H__);
    require 'asm/ioctl.ph';
    eval 'sub TCGETS () { &_IOR(ord(\'T\'), 16, \'struct termios\');}' unless defined(&TCGETS);
    eval 'sub TCSETS () { &_IOW(ord(\'T\'), 17, \'struct termios\');}' unless defined(&TCSETS);
    eval 'sub TCSETSW () { &_IOW(ord(\'T\'), 18, \'struct termios\');}' unless defined(&TCSETSW);
    eval 'sub TCSETSF () { &_IOW(ord(\'T\'), 19, \'struct termios\');}' unless defined(&TCSETSF);
    eval 'sub TCGETA () { &_IOR(ord(\'T\'), 1, \'struct termio\');}' unless defined(&TCGETA);
    eval 'sub TCSETA () { &_IOW(ord(\'T\'), 2, \'struct termio\');}' unless defined(&TCSETA);
    eval 'sub TCSETAW () { &_IOW(ord(\'T\'), 3, \'struct termio\');}' unless defined(&TCSETAW);
    eval 'sub TCSETAF () { &_IOW(ord(\'T\'), 4, \'struct termio\');}' unless defined(&TCSETAF);
    eval 'sub TCSBRK () { &_IO(ord(\'T\'), 5);}' unless defined(&TCSBRK);
    eval 'sub TCXONC () { &_IO(ord(\'T\'), 6);}' unless defined(&TCXONC);
    eval 'sub TCFLSH () { &_IO(ord(\'T\'), 7);}' unless defined(&TCFLSH);
    eval 'sub TIOCEXCL () {0x540c;}' unless defined(&TIOCEXCL);
    eval 'sub TIOCNXCL () {0x540d;}' unless defined(&TIOCNXCL);
    eval 'sub TIOCSCTTY () {0x540e;}' unless defined(&TIOCSCTTY);
    eval 'sub TIOCGPGRP () { &_IOR(ord(\'T\'), 30, \'int\');}' unless defined(&TIOCGPGRP);
    eval 'sub TIOCSPGRP () { &_IOW(ord(\'T\'), 29, \'int\');}' unless defined(&TIOCSPGRP);
    eval 'sub TIOCOUTQ () {0x5411;}' unless defined(&TIOCOUTQ);
    eval 'sub TIOCSTI () {0x5412;}' unless defined(&TIOCSTI);
    eval 'sub TIOCGWINSZ () {0x5413;}' unless defined(&TIOCGWINSZ);
    eval 'sub TIOCSWINSZ () {0x5414;}' unless defined(&TIOCSWINSZ);
    eval 'sub TIOCMGET () {0x5415;}' unless defined(&TIOCMGET);
    eval 'sub TIOCMBIS () {0x5416;}' unless defined(&TIOCMBIS);
    eval 'sub TIOCMBIC () {0x5417;}' unless defined(&TIOCMBIC);
    eval 'sub TIOCMSET () {0x5418;}' unless defined(&TIOCMSET);
    eval 'sub TIOCGSOFTCAR () {0x5419;}' unless defined(&TIOCGSOFTCAR);
    eval 'sub TIOCSSOFTCAR () {0x541a;}' unless defined(&TIOCSSOFTCAR);
    eval 'sub FIONREAD () {0x541b;}' unless defined(&FIONREAD);
    eval 'sub TIOCINQ () { &FIONREAD;}' unless defined(&TIOCINQ);
    eval 'sub TIOCLINUX () {0x541c;}' unless defined(&TIOCLINUX);
    eval 'sub TIOCCONS () {0x541d;}' unless defined(&TIOCCONS);
    eval 'sub TIOCGSERIAL () {0x541e;}' unless defined(&TIOCGSERIAL);
    eval 'sub TIOCSSERIAL () {0x541f;}' unless defined(&TIOCSSERIAL);
    eval 'sub TIOCPKT () {0x5420;}' unless defined(&TIOCPKT);
    eval 'sub FIONBIO () {0x5421;}' unless defined(&FIONBIO);
    eval 'sub TIOCNOTTY () {0x5422;}' unless defined(&TIOCNOTTY);
    eval 'sub TIOCSETD () {0x5423;}' unless defined(&TIOCSETD);
    eval 'sub TIOCGETD () {0x5424;}' unless defined(&TIOCGETD);
    eval 'sub TCSBRKP () {0x5425;}' unless defined(&TCSBRKP);
    eval 'sub TIOCSBRK () {0x5427;}' unless defined(&TIOCSBRK);
    eval 'sub TIOCCBRK () {0x5428;}' unless defined(&TIOCCBRK);
    eval 'sub TIOCGSID () { &_IOR(ord(\'T\'), 20, \'int\');}' unless defined(&TIOCGSID);
    eval 'sub TIOCGPTN () { &_IOR(ord(\'T\'),0x30, \'unsigned int\');}' unless defined(&TIOCGPTN);
    eval 'sub TIOCSPTLCK () { &_IOW(ord(\'T\'),0x31, \'int\');}' unless defined(&TIOCSPTLCK);
    eval 'sub FIONCLEX () {0x5450;}' unless defined(&FIONCLEX);
    eval 'sub FIOCLEX () {0x5451;}' unless defined(&FIOCLEX);
    eval 'sub FIOASYNC () {0x5452;}' unless defined(&FIOASYNC);
    eval 'sub TIOCSERCONFIG () {0x5453;}' unless defined(&TIOCSERCONFIG);
    eval 'sub TIOCSERGWILD () {0x5454;}' unless defined(&TIOCSERGWILD);
    eval 'sub TIOCSERSWILD () {0x5455;}' unless defined(&TIOCSERSWILD);
    eval 'sub TIOCGLCKTRMIOS () {0x5456;}' unless defined(&TIOCGLCKTRMIOS);
    eval 'sub TIOCSLCKTRMIOS () {0x5457;}' unless defined(&TIOCSLCKTRMIOS);
    eval 'sub TIOCSERGSTRUCT () {0x5458;}' unless defined(&TIOCSERGSTRUCT);
    eval 'sub TIOCSERGETLSR () {0x5459;}' unless defined(&TIOCSERGETLSR);
    eval 'sub TIOCSERGETMULTI () {0x545a;}' unless defined(&TIOCSERGETMULTI);
    eval 'sub TIOCSERSETMULTI () {0x545b;}' unless defined(&TIOCSERSETMULTI);
    eval 'sub TIOCMIWAIT () {0x545c;}' unless defined(&TIOCMIWAIT);
    eval 'sub TIOCGICOUNT () {0x545d;}' unless defined(&TIOCGICOUNT);
    eval 'sub TIOCGHAYESESP () {0x545e;}' unless defined(&TIOCGHAYESESP);
    eval 'sub TIOCSHAYESESP () {0x545f;}' unless defined(&TIOCSHAYESESP);
    eval 'sub FIOQSIZE () {0x5460;}' unless defined(&FIOQSIZE);
    eval 'sub TIOCSTART () {0x5461;}' unless defined(&TIOCSTART);
    eval 'sub TIOCSTOP () {0x5462;}' unless defined(&TIOCSTOP);
    eval 'sub TIOCSLTC () {0x5462;}' unless defined(&TIOCSLTC);
    eval 'sub TIOCPKT_DATA () {0;}' unless defined(&TIOCPKT_DATA);
    eval 'sub TIOCPKT_FLUSHREAD () {1;}' unless defined(&TIOCPKT_FLUSHREAD);
    eval 'sub TIOCPKT_FLUSHWRITE () {2;}' unless defined(&TIOCPKT_FLUSHWRITE);
    eval 'sub TIOCPKT_STOP () {4;}' unless defined(&TIOCPKT_STOP);
    eval 'sub TIOCPKT_START () {8;}' unless defined(&TIOCPKT_START);
    eval 'sub TIOCPKT_NOSTOP () {16;}' unless defined(&TIOCPKT_NOSTOP);
    eval 'sub TIOCPKT_DOSTOP () {32;}' unless defined(&TIOCPKT_DOSTOP);
    eval 'sub TIOCSER_TEMT () {0x1;}' unless defined(&TIOCSER_TEMT);
}
1;
