require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_PARISC_IRQ_H)) {
    eval 'sub _ASM_PARISC_IRQ_H () {1;}' unless defined(&_ASM_PARISC_IRQ_H);
    require 'linux/config.ph';
    require 'asm/types.ph';
    eval 'sub NO_IRQ () {(-1);}' unless defined(&NO_IRQ);
    if(defined(&CONFIG_GSC)) {
	eval 'sub GSC_IRQ_BASE () {16;}' unless defined(&GSC_IRQ_BASE);
	eval 'sub GSC_IRQ_MAX () {63;}' unless defined(&GSC_IRQ_MAX);
	eval 'sub CPU_IRQ_BASE () {64;}' unless defined(&CPU_IRQ_BASE);
    } else {
	eval 'sub CPU_IRQ_BASE () {16;}' unless defined(&CPU_IRQ_BASE);
    }
    eval 'sub TIMER_IRQ () {( &CPU_IRQ_BASE + 0);}' unless defined(&TIMER_IRQ);
    eval 'sub IPI_IRQ () {( &CPU_IRQ_BASE + 1);}' unless defined(&IPI_IRQ);
    eval 'sub CPU_IRQ_MAX () {( &CPU_IRQ_BASE + ( &BITS_PER_LONG - 1));}' unless defined(&CPU_IRQ_MAX);
    eval 'sub NR_IRQS () {( &CPU_IRQ_MAX + 1);}' unless defined(&NR_IRQS);
    eval 'sub irq_canonicalize {
        my($irq) = @_;
	    eval q({ ($irq == 2) ? 9: $irq; });
    }' unless defined(&irq_canonicalize);
}
1;
