require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__PARISC_MMU_CONTEXT_H)) {
    eval 'sub __PARISC_MMU_CONTEXT_H () {1;}' unless defined(&__PARISC_MMU_CONTEXT_H);
    require 'linux/mm.ph';
    require 'asm/atomic.ph';
    require 'asm/pgalloc.ph';
    require 'asm/pgtable.ph';
    eval 'sub enter_lazy_tlb {
        my($mm,$tsk) = @_;
	    eval q({ });
    }' unless defined(&enter_lazy_tlb);
    eval 'sub init_new_context {
        my($tsk,$mm) = @_;
	    eval q({  &BUG_ON( &atomic_read( ($mm->{mm_users})) != 1);  ($mm->{context}) =  &alloc_sid(); 0; });
    }' unless defined(&init_new_context);
    eval 'sub destroy_context {
        my($mm) = @_;
	    eval q({  &free_sid( ($mm->{context}));  ($mm->{context}) = 0; });
    }' unless defined(&destroy_context);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub load_context {
        my($context) = @_;
	    eval q({  &mtsp($context, 3); });
    }' unless defined(&load_context);
    eval 'sub switch_mm {
        my($prev,$next,$tsk) = @_;
	    eval q({  &if ($prev != $next) {  &mtctl( &__pa( ($next->{pgd})), 25);  &load_context( ($next->{context})); } });
    }' unless defined(&switch_mm);
    eval 'sub deactivate_mm {
        my($tsk,$mm) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&deactivate_mm);
    eval 'sub activate_mm {
        my($prev,$next) = @_;
	    eval q({  &BUG_ON($next ==  &init_mm);  &if ( ($next->{context}) == 0)  ($next->{context}) =  &alloc_sid();  &switch_mm($prev,$next, &current); });
    }' unless defined(&activate_mm);
}
1;
