require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_PARISC_PCI_H)) {
    eval 'sub __ASM_PARISC_PCI_H () {1;}' unless defined(&__ASM_PARISC_PCI_H);
    require 'linux/config.ph';
    require 'asm/scatterlist.ph';
    eval 'sub PCI_MAX_BUSSES () {256;}' unless defined(&PCI_MAX_BUSSES);
    eval 'sub DINO_MAX_LMMIO_RESOURCES () {3;}' unless defined(&DINO_MAX_LMMIO_RESOURCES);
    eval 'sub HBA_NAME_SIZE () {16;}' unless defined(&HBA_NAME_SIZE);
    eval 'sub HBA_DATA {
        my($d) = @_;
	    eval q(( ($d)));
    }' unless defined(&HBA_DATA);
    eval 'sub HBA_PORT_SPACE_BITS () {16;}' unless defined(&HBA_PORT_SPACE_BITS);
    eval 'sub HBA_PORT_BASE {
        my($h) = @_;
	    eval q((($h) <<  &HBA_PORT_SPACE_BITS));
    }' unless defined(&HBA_PORT_BASE);
    eval 'sub HBA_PORT_SPACE_SIZE () {(1 <<  &HBA_PORT_SPACE_BITS);}' unless defined(&HBA_PORT_SPACE_SIZE);
    eval 'sub PCI_PORT_HBA {
        my($a) = @_;
	    eval q((($a) >>  &HBA_PORT_SPACE_BITS));
    }' unless defined(&PCI_PORT_HBA);
    eval 'sub PCI_PORT_ADDR {
        my($a) = @_;
	    eval q((($a) & ( &HBA_PORT_SPACE_SIZE - 1)));
    }' unless defined(&PCI_PORT_ADDR);
    if((defined(&CONFIG_PARISC64) ? &CONFIG_PARISC64 : 0)) {
	eval 'sub PCI_F_EXTEND () {1.84467440694146e+19;}' unless defined(&PCI_F_EXTEND);
	eval 'sub PCI_IS_LMMIO {
	    my($hba,$a) = @_;
    	    eval q( &pci_is_lmmio($hba,$a));
	}' unless defined(&PCI_IS_LMMIO);
	eval 'sub PCI_BUS_ADDR {
	    my($hba,$a) = @_;
    	    eval q(( &PCI_IS_LMMIO($hba,$a) ? (($a) -  ($hba->{lmmio_space_offset})) : ($a)));
	}' unless defined(&PCI_BUS_ADDR);
	eval 'sub PCI_HOST_ADDR {
	    my($hba,$a) = @_;
    	    eval q((($a) +  ($hba->{lmmio_space_offset})));
	}' unless defined(&PCI_HOST_ADDR);
    } else {
	eval 'sub PCI_BUS_ADDR {
	    my($hba,$a) = @_;
    	    eval q(($a));
	}' unless defined(&PCI_BUS_ADDR);
	eval 'sub PCI_HOST_ADDR {
	    my($hba,$a) = @_;
    	    eval q(($a));
	}' unless defined(&PCI_HOST_ADDR);
	eval 'sub PCI_F_EXTEND () {0;}' unless defined(&PCI_F_EXTEND);
	eval 'sub PCI_IS_LMMIO {
	    my($hba,$a) = @_;
    	    eval q((1));
	}' unless defined(&PCI_IS_LMMIO);
    }
    eval 'sub PCI_DMA_BUS_IS_PHYS () {(1);}' unless defined(&PCI_DMA_BUS_IS_PHYS);
    eval 'sub DECLARE_PCI_UNMAP_ADDR {
        my($ADDR_NAME) = @_;
	    eval q( &dma_addr_t $ADDR_NAME;);
    }' unless defined(&DECLARE_PCI_UNMAP_ADDR);
    eval 'sub DECLARE_PCI_UNMAP_LEN {
        my($LEN_NAME) = @_;
	    eval q( &__u32 $LEN_NAME;);
    }' unless defined(&DECLARE_PCI_UNMAP_LEN);
    eval 'sub pci_unmap_addr {
        my($PTR, $ADDR_NAME) = @_;
	    eval q((($PTR)->$ADDR_NAME));
    }' unless defined(&pci_unmap_addr);
    eval 'sub pci_unmap_addr_set {
        my($PTR, $ADDR_NAME, $VAL) = @_;
	    eval q(((($PTR)->$ADDR_NAME) = ($VAL)));
    }' unless defined(&pci_unmap_addr_set);
    eval 'sub pci_unmap_len {
        my($PTR, $LEN_NAME) = @_;
	    eval q((($PTR)->$LEN_NAME));
    }' unless defined(&pci_unmap_len);
    eval 'sub pci_unmap_len_set {
        my($PTR, $LEN_NAME, $VAL) = @_;
	    eval q(((($PTR)->$LEN_NAME) = ($VAL)));
    }' unless defined(&pci_unmap_len_set);
    if(defined(&CONFIG_PCI)) {
    } else {
    }
    eval 'sub pcibios_assign_all_busses () {
        eval q(( &pdc_type ==  &PDC_TYPE_PAT));
    }' unless defined(&pcibios_assign_all_busses);
    eval 'sub pcibios_scan_all_fns {
        my($a, $b) = @_;
	    eval q(0);
    }' unless defined(&pcibios_scan_all_fns);
    eval 'sub PCIBIOS_MIN_IO () {0x10;}' unless defined(&PCIBIOS_MIN_IO);
    eval 'sub PCIBIOS_MIN_MEM () {0x1000;}' unless defined(&PCIBIOS_MIN_MEM);
    eval 'sub pci_dac_dma_supported {
        my($pci_dev, $mask) = @_;
	    eval q((0));
    }' unless defined(&pci_dac_dma_supported);
    require 'asm-generic/pci-dma-compat.ph';
    eval 'sub pcibios_add_platform_entries {
        my($dev) = @_;
	    eval q({ });
    }' unless defined(&pcibios_add_platform_entries);
}
1;
