require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PARISC_PDC_H)) {
    eval 'sub _PARISC_PDC_H () {1;}' unless defined(&_PARISC_PDC_H);
    require 'linux/config.ph';
    eval 'sub PDC_WARN () {3;}' unless defined(&PDC_WARN);
    eval 'sub PDC_REQ_ERR_1 () {2;}' unless defined(&PDC_REQ_ERR_1);
    eval 'sub PDC_REQ_ERR_0 () {1;}' unless defined(&PDC_REQ_ERR_0);
    eval 'sub PDC_OK () {0;}' unless defined(&PDC_OK);
    eval 'sub PDC_BAD_PROC () {-1;}' unless defined(&PDC_BAD_PROC);
    eval 'sub PDC_BAD_OPTION () {-2;}' unless defined(&PDC_BAD_OPTION);
    eval 'sub PDC_ERROR () {-3;}' unless defined(&PDC_ERROR);
    eval 'sub PDC_NE_MOD () {-5;}' unless defined(&PDC_NE_MOD);
    eval 'sub PDC_NE_CELL_MOD () {-7;}' unless defined(&PDC_NE_CELL_MOD);
    eval 'sub PDC_INVALID_ARG () {-10;}' unless defined(&PDC_INVALID_ARG);
    eval 'sub PDC_BUS_POW_WARN () {-12;}' unless defined(&PDC_BUS_POW_WARN);
    eval 'sub PDC_NOT_NARROW () {-17;}' unless defined(&PDC_NOT_NARROW);
    eval 'sub PDC_POW_FAIL () {1;}' unless defined(&PDC_POW_FAIL);
    eval 'sub PDC_POW_FAIL_PREPARE () {0;}' unless defined(&PDC_POW_FAIL_PREPARE);
    eval 'sub PDC_CHASSIS () {2;}' unless defined(&PDC_CHASSIS);
    eval 'sub PDC_CHASSIS_DISP () {0;}' unless defined(&PDC_CHASSIS_DISP);
    eval 'sub PDC_CHASSIS_WARN () {1;}' unless defined(&PDC_CHASSIS_WARN);
    eval 'sub PDC_CHASSIS_DISPWARN () {2;}' unless defined(&PDC_CHASSIS_DISPWARN);
    eval 'sub PDC_RETURN_CHASSIS_INFO () {128;}' unless defined(&PDC_RETURN_CHASSIS_INFO);
    eval 'sub PDC_PIM () {3;}' unless defined(&PDC_PIM);
    eval 'sub PDC_PIM_HPMC () {0;}' unless defined(&PDC_PIM_HPMC);
    eval 'sub PDC_PIM_RETURN_SIZE () {1;}' unless defined(&PDC_PIM_RETURN_SIZE);
    eval 'sub PDC_PIM_LPMC () {2;}' unless defined(&PDC_PIM_LPMC);
    eval 'sub PDC_PIM_SOFT_BOOT () {3;}' unless defined(&PDC_PIM_SOFT_BOOT);
    eval 'sub PDC_PIM_TOC () {4;}' unless defined(&PDC_PIM_TOC);
    eval 'sub PDC_MODEL () {4;}' unless defined(&PDC_MODEL);
    eval 'sub PDC_MODEL_INFO () {0;}' unless defined(&PDC_MODEL_INFO);
    eval 'sub PDC_MODEL_BOOTID () {1;}' unless defined(&PDC_MODEL_BOOTID);
    eval 'sub PDC_MODEL_VERSIONS () {2;}' unless defined(&PDC_MODEL_VERSIONS);
    eval 'sub PDC_MODEL_SYSMODEL () {3;}' unless defined(&PDC_MODEL_SYSMODEL);
    eval 'sub PDC_MODEL_ENSPEC () {4;}' unless defined(&PDC_MODEL_ENSPEC);
    eval 'sub PDC_MODEL_DISPEC () {5;}' unless defined(&PDC_MODEL_DISPEC);
    eval 'sub PDC_MODEL_CPU_ID () {6;}' unless defined(&PDC_MODEL_CPU_ID);
    eval 'sub PDC_MODEL_CAPABILITIES () {7;}' unless defined(&PDC_MODEL_CAPABILITIES);
    eval 'sub PDC_MODEL_GET_BOOT__OP () {8;}' unless defined(&PDC_MODEL_GET_BOOT__OP);
    eval 'sub PDC_MODEL_SET_BOOT__OP () {9;}' unless defined(&PDC_MODEL_SET_BOOT__OP);
    eval 'sub PA89_INSTRUCTION_SET () {0x4;}' unless defined(&PA89_INSTRUCTION_SET);
    eval 'sub PA90_INSTRUCTION_SET () {0x8;}' unless defined(&PA90_INSTRUCTION_SET);
    eval 'sub PDC_CACHE () {5;}' unless defined(&PDC_CACHE);
    eval 'sub PDC_CACHE_INFO () {0;}' unless defined(&PDC_CACHE_INFO);
    eval 'sub PDC_CACHE_SET_COH () {1;}' unless defined(&PDC_CACHE_SET_COH);
    eval 'sub PDC_CACHE_RET_SPID () {2;}' unless defined(&PDC_CACHE_RET_SPID);
    eval 'sub PDC_HPA () {6;}' unless defined(&PDC_HPA);
    eval 'sub PDC_HPA_PROCESSOR () {0;}' unless defined(&PDC_HPA_PROCESSOR);
    eval 'sub PDC_HPA_MODULES () {1;}' unless defined(&PDC_HPA_MODULES);
    eval 'sub PDC_COPROC () {7;}' unless defined(&PDC_COPROC);
    eval 'sub PDC_COPROC_CFG () {0;}' unless defined(&PDC_COPROC_CFG);
    eval 'sub PDC_IODC () {8;}' unless defined(&PDC_IODC);
    eval 'sub PDC_IODC_READ () {0;}' unless defined(&PDC_IODC_READ);
    eval 'sub PDC_IODC_RI_DATA_BYTES () {0;}' unless defined(&PDC_IODC_RI_DATA_BYTES);
    eval 'sub PDC_IODC_RI_INIT () {3;}' unless defined(&PDC_IODC_RI_INIT);
    eval 'sub PDC_IODC_RI_IO () {4;}' unless defined(&PDC_IODC_RI_IO);
    eval 'sub PDC_IODC_RI_SPA () {5;}' unless defined(&PDC_IODC_RI_SPA);
    eval 'sub PDC_IODC_RI_CONFIG () {6;}' unless defined(&PDC_IODC_RI_CONFIG);
    eval 'sub PDC_IODC_RI_TEST () {8;}' unless defined(&PDC_IODC_RI_TEST);
    eval 'sub PDC_IODC_RI_TLB () {9;}' unless defined(&PDC_IODC_RI_TLB);
    eval 'sub PDC_IODC_NINIT () {2;}' unless defined(&PDC_IODC_NINIT);
    eval 'sub PDC_IODC_DINIT () {3;}' unless defined(&PDC_IODC_DINIT);
    eval 'sub PDC_IODC_MEMERR () {4;}' unless defined(&PDC_IODC_MEMERR);
    eval 'sub PDC_IODC_INDEX_DATA () {0;}' unless defined(&PDC_IODC_INDEX_DATA);
    eval 'sub PDC_IODC_BUS_ERROR () {-4;}' unless defined(&PDC_IODC_BUS_ERROR);
    eval 'sub PDC_IODC_INVALID_INDEX () {-5;}' unless defined(&PDC_IODC_INVALID_INDEX);
    eval 'sub PDC_IODC_COUNT () {-6;}' unless defined(&PDC_IODC_COUNT);
    eval 'sub PDC_TOD () {9;}' unless defined(&PDC_TOD);
    eval 'sub PDC_TOD_READ () {0;}' unless defined(&PDC_TOD_READ);
    eval 'sub PDC_TOD_WRITE () {1;}' unless defined(&PDC_TOD_WRITE);
    eval 'sub PDC_TOD_ITIMER () {2;}' unless defined(&PDC_TOD_ITIMER);
    eval 'sub PDC_STABLE () {10;}' unless defined(&PDC_STABLE);
    eval 'sub PDC_STABLE_READ () {0;}' unless defined(&PDC_STABLE_READ);
    eval 'sub PDC_STABLE_WRITE () {1;}' unless defined(&PDC_STABLE_WRITE);
    eval 'sub PDC_STABLE_RETURN_SIZE () {2;}' unless defined(&PDC_STABLE_RETURN_SIZE);
    eval 'sub PDC_STABLE_VERIFY_CONTENTS () {3;}' unless defined(&PDC_STABLE_VERIFY_CONTENTS);
    eval 'sub PDC_STABLE_INITIALIZE () {4;}' unless defined(&PDC_STABLE_INITIALIZE);
    eval 'sub PDC_NVOLATILE () {11;}' unless defined(&PDC_NVOLATILE);
    eval 'sub PDC_ADD_VALID () {12;}' unless defined(&PDC_ADD_VALID);
    eval 'sub PDC_ADD_VALID_VERIFY () {0;}' unless defined(&PDC_ADD_VALID_VERIFY);
    eval 'sub PDC_INSTR () {15;}' unless defined(&PDC_INSTR);
    eval 'sub PDC_PROC () {16;}' unless defined(&PDC_PROC);
    eval 'sub PDC_CONFIG () {16;}' unless defined(&PDC_CONFIG);
    eval 'sub PDC_CONFIG_DECONFIG () {0;}' unless defined(&PDC_CONFIG_DECONFIG);
    eval 'sub PDC_CONFIG_DRECONFIG () {1;}' unless defined(&PDC_CONFIG_DRECONFIG);
    eval 'sub PDC_CONFIG_DRETURN_CONFIG () {2;}' unless defined(&PDC_CONFIG_DRETURN_CONFIG);
    eval 'sub PDC_BLOCK_TLB () {18;}' unless defined(&PDC_BLOCK_TLB);
    eval 'sub PDC_BTLB_INFO () {0;}' unless defined(&PDC_BTLB_INFO);
    eval 'sub PDC_BTLB_INSERT () {1;}' unless defined(&PDC_BTLB_INSERT);
    eval 'sub PDC_BTLB_PURGE () {2;}' unless defined(&PDC_BTLB_PURGE);
    eval 'sub PDC_BTLB_PURGE_ALL () {3;}' unless defined(&PDC_BTLB_PURGE_ALL);
    eval 'sub PDC_TLB () {19;}' unless defined(&PDC_TLB);
    eval 'sub PDC_TLB_INFO () {0;}' unless defined(&PDC_TLB_INFO);
    eval 'sub PDC_TLB_SETUP () {1;}' unless defined(&PDC_TLB_SETUP);
    eval 'sub PDC_MEM () {20;}' unless defined(&PDC_MEM);
    eval 'sub PDC_MEM_MEMINFO () {0;}' unless defined(&PDC_MEM_MEMINFO);
    eval 'sub PDC_MEM_ADD_PAGE () {1;}' unless defined(&PDC_MEM_ADD_PAGE);
    eval 'sub PDC_MEM_CLEAR_PDT () {2;}' unless defined(&PDC_MEM_CLEAR_PDT);
    eval 'sub PDC_MEM_READ_PDT () {3;}' unless defined(&PDC_MEM_READ_PDT);
    eval 'sub PDC_MEM_RESET_CLEAR () {4;}' unless defined(&PDC_MEM_RESET_CLEAR);
    eval 'sub PDC_MEM_GOODMEM () {5;}' unless defined(&PDC_MEM_GOODMEM);
    eval 'sub PDC_MEM_TABLE () {128;}' unless defined(&PDC_MEM_TABLE);
    eval 'sub PDC_MEM_RETURN_ADDRESS_TABLE () { &PDC_MEM_TABLE;}' unless defined(&PDC_MEM_RETURN_ADDRESS_TABLE);
    eval 'sub PDC_MEM_GET_MEMORY_SYSTEM_TABLES_SIZE () {131;}' unless defined(&PDC_MEM_GET_MEMORY_SYSTEM_TABLES_SIZE);
    eval 'sub PDC_MEM_GET_MEMORY_SYSTEM_TABLES () {132;}' unless defined(&PDC_MEM_GET_MEMORY_SYSTEM_TABLES);
    eval 'sub PDC_MEM_GET_PHYSICAL_LOCATION_FROM_MEMORY_ADDRESS () {133;}' unless defined(&PDC_MEM_GET_PHYSICAL_LOCATION_FROM_MEMORY_ADDRESS);
    eval 'sub PDC_MEM_RET_SBE_REPLACED () {5;}' unless defined(&PDC_MEM_RET_SBE_REPLACED);
    eval 'sub PDC_MEM_RET_DUPLICATE_ENTRY () {4;}' unless defined(&PDC_MEM_RET_DUPLICATE_ENTRY);
    eval 'sub PDC_MEM_RET_BUF_SIZE_SMALL () {1;}' unless defined(&PDC_MEM_RET_BUF_SIZE_SMALL);
    eval 'sub PDC_MEM_RET_PDT_FULL () {-11;}' unless defined(&PDC_MEM_RET_PDT_FULL);
    eval 'sub PDC_MEM_RET_INVALID_PHYSICAL_LOCATION () {~0;}' unless defined(&PDC_MEM_RET_INVALID_PHYSICAL_LOCATION);
    unless(defined(&__ASSEMBLY__)) {
    }
    eval 'sub PDC_PSW () {21;}' unless defined(&PDC_PSW);
    eval 'sub PDC_PSW_MASK () {0;}' unless defined(&PDC_PSW_MASK);
    eval 'sub PDC_PSW_GET_DEFAULTS () {1;}' unless defined(&PDC_PSW_GET_DEFAULTS);
    eval 'sub PDC_PSW_SET_DEFAULTS () {2;}' unless defined(&PDC_PSW_SET_DEFAULTS);
    eval 'sub PDC_PSW_ENDIAN_BIT () {1;}' unless defined(&PDC_PSW_ENDIAN_BIT);
    eval 'sub PDC_PSW_WIDE_BIT () {2;}' unless defined(&PDC_PSW_WIDE_BIT);
    eval 'sub PDC_SYSTEM_MAP () {22;}' unless defined(&PDC_SYSTEM_MAP);
    eval 'sub PDC_FIND_MODULE () {0;}' unless defined(&PDC_FIND_MODULE);
    eval 'sub PDC_FIND_ADDRESS () {1;}' unless defined(&PDC_FIND_ADDRESS);
    eval 'sub PDC_TRANSLATE_PATH () {2;}' unless defined(&PDC_TRANSLATE_PATH);
    eval 'sub PDC_SOFT_POWER () {23;}' unless defined(&PDC_SOFT_POWER);
    eval 'sub PDC_SOFT_POWER_INFO () {0;}' unless defined(&PDC_SOFT_POWER_INFO);
    eval 'sub PDC_SOFT_POWER_ENABLE () {1;}' unless defined(&PDC_SOFT_POWER_ENABLE);
    eval 'sub PDC_MEM_MAP () {128;}' unless defined(&PDC_MEM_MAP);
    eval 'sub PDC_MEM_MAP_HPA () {0;}' unless defined(&PDC_MEM_MAP_HPA);
    eval 'sub PDC_EEPROM () {129;}' unless defined(&PDC_EEPROM);
    eval 'sub PDC_EEPROM_READ_WORD () {0;}' unless defined(&PDC_EEPROM_READ_WORD);
    eval 'sub PDC_EEPROM_WRITE_WORD () {1;}' unless defined(&PDC_EEPROM_WRITE_WORD);
    eval 'sub PDC_EEPROM_READ_BYTE () {2;}' unless defined(&PDC_EEPROM_READ_BYTE);
    eval 'sub PDC_EEPROM_WRITE_BYTE () {3;}' unless defined(&PDC_EEPROM_WRITE_BYTE);
    eval 'sub PDC_EEPROM_EEPROM_PASSWORD () {-1000;}' unless defined(&PDC_EEPROM_EEPROM_PASSWORD);
    eval 'sub PDC_NVM () {130;}' unless defined(&PDC_NVM);
    eval 'sub PDC_NVM_READ_WORD () {0;}' unless defined(&PDC_NVM_READ_WORD);
    eval 'sub PDC_NVM_WRITE_WORD () {1;}' unless defined(&PDC_NVM_WRITE_WORD);
    eval 'sub PDC_NVM_READ_BYTE () {2;}' unless defined(&PDC_NVM_READ_BYTE);
    eval 'sub PDC_NVM_WRITE_BYTE () {3;}' unless defined(&PDC_NVM_WRITE_BYTE);
    eval 'sub PDC_SEED_ERROR () {132;}' unless defined(&PDC_SEED_ERROR);
    eval 'sub PDC_IO () {135;}' unless defined(&PDC_IO);
    eval 'sub PDC_IO_READ_AND_CLEAR_ERRORS () {0;}' unless defined(&PDC_IO_READ_AND_CLEAR_ERRORS);
    eval 'sub PDC_IO_RESET () {1;}' unless defined(&PDC_IO_RESET);
    eval 'sub PDC_IO_RESET_DEVICES () {2;}' unless defined(&PDC_IO_RESET_DEVICES);
    eval 'sub PDC_IO_USB_SUSPEND () {1.38350580552822e+19;}' unless defined(&PDC_IO_USB_SUSPEND);
    eval 'sub PDC_IO_EEPROM_IO_ERR_TABLE_FULL () {-5;}' unless defined(&PDC_IO_EEPROM_IO_ERR_TABLE_FULL);
    eval 'sub PDC_IO_NO_SUSPEND () {-6;}' unless defined(&PDC_IO_NO_SUSPEND);
    eval 'sub PDC_BROADCAST_RESET () {136;}' unless defined(&PDC_BROADCAST_RESET);
    eval 'sub PDC_DO_RESET () {0;}' unless defined(&PDC_DO_RESET);
    eval 'sub PDC_DO_FIRM_TEST_RESET () {1;}' unless defined(&PDC_DO_FIRM_TEST_RESET);
    eval 'sub PDC_BR_RECONFIGURATION () {2;}' unless defined(&PDC_BR_RECONFIGURATION);
    eval 'sub PDC_FIRM_TEST_MAGIC () {0xab9ec36f;}' unless defined(&PDC_FIRM_TEST_MAGIC);
    eval 'sub PDC_LAN_STATION_ID () {138;}' unless defined(&PDC_LAN_STATION_ID);
    eval 'sub PDC_LAN_STATION_ID_READ () {0;}' unless defined(&PDC_LAN_STATION_ID_READ);
    eval 'sub PDC_LAN_STATION_ID_SIZE () {6;}' unless defined(&PDC_LAN_STATION_ID_SIZE);
    eval 'sub PDC_CHECK_RANGES () {139;}' unless defined(&PDC_CHECK_RANGES);
    eval 'sub PDC_NV_SECTIONS () {141;}' unless defined(&PDC_NV_SECTIONS);
    eval 'sub PDC_PERFORMANCE () {142;}' unless defined(&PDC_PERFORMANCE);
    eval 'sub PDC_SYSTEM_INFO () {143;}' unless defined(&PDC_SYSTEM_INFO);
    eval 'sub PDC_SYSINFO_RETURN_INFO_SIZE () {0;}' unless defined(&PDC_SYSINFO_RETURN_INFO_SIZE);
    eval 'sub PDC_SYSINFO_RRETURN_SYS_INFO () {1;}' unless defined(&PDC_SYSINFO_RRETURN_SYS_INFO);
    eval 'sub PDC_SYSINFO_RRETURN_ERRORS () {2;}' unless defined(&PDC_SYSINFO_RRETURN_ERRORS);
    eval 'sub PDC_SYSINFO_RRETURN_WARNINGS () {3;}' unless defined(&PDC_SYSINFO_RRETURN_WARNINGS);
    eval 'sub PDC_SYSINFO_RETURN_REVISIONS () {4;}' unless defined(&PDC_SYSINFO_RETURN_REVISIONS);
    eval 'sub PDC_SYSINFO_RRETURN_DIAGNOSE () {5;}' unless defined(&PDC_SYSINFO_RRETURN_DIAGNOSE);
    eval 'sub PDC_SYSINFO_RRETURN_HV_DIAGNOSE () {1005;}' unless defined(&PDC_SYSINFO_RRETURN_HV_DIAGNOSE);
    eval 'sub PDC_RDR () {144;}' unless defined(&PDC_RDR);
    eval 'sub PDC_RDR_READ_BUFFER () {0;}' unless defined(&PDC_RDR_READ_BUFFER);
    eval 'sub PDC_RDR_READ_SINGLE () {1;}' unless defined(&PDC_RDR_READ_SINGLE);
    eval 'sub PDC_RDR_WRITE_SINGLE () {2;}' unless defined(&PDC_RDR_WRITE_SINGLE);
    eval 'sub PDC_INTRIGUE () {145;}' unless defined(&PDC_INTRIGUE);
    eval 'sub PDC_INTRIGUE_WRITE_BUFFER () {0;}' unless defined(&PDC_INTRIGUE_WRITE_BUFFER);
    eval 'sub PDC_INTRIGUE_GET_SCRATCH_BUFSIZE () {1;}' unless defined(&PDC_INTRIGUE_GET_SCRATCH_BUFSIZE);
    eval 'sub PDC_INTRIGUE_START_CPU_COUNTERS () {2;}' unless defined(&PDC_INTRIGUE_START_CPU_COUNTERS);
    eval 'sub PDC_INTRIGUE_STOP_CPU_COUNTERS () {3;}' unless defined(&PDC_INTRIGUE_STOP_CPU_COUNTERS);
    eval 'sub PDC_STI () {146;}' unless defined(&PDC_STI);
    eval 'sub PDC_PCI_INDEX () {147;}' unless defined(&PDC_PCI_INDEX);
    eval 'sub PDC_PCI_INTERFACE_INFO () {0;}' unless defined(&PDC_PCI_INTERFACE_INFO);
    eval 'sub PDC_PCI_SLOT_INFO () {1;}' unless defined(&PDC_PCI_SLOT_INFO);
    eval 'sub PDC_PCI_INFLIGHT_BYTES () {2;}' unless defined(&PDC_PCI_INFLIGHT_BYTES);
    eval 'sub PDC_PCI_READ_CONFIG () {3;}' unless defined(&PDC_PCI_READ_CONFIG);
    eval 'sub PDC_PCI_WRITE_CONFIG () {4;}' unless defined(&PDC_PCI_WRITE_CONFIG);
    eval 'sub PDC_PCI_READ_PCI_IO () {5;}' unless defined(&PDC_PCI_READ_PCI_IO);
    eval 'sub PDC_PCI_WRITE_PCI_IO () {6;}' unless defined(&PDC_PCI_WRITE_PCI_IO);
    eval 'sub PDC_PCI_READ_CONFIG_DELAY () {7;}' unless defined(&PDC_PCI_READ_CONFIG_DELAY);
    eval 'sub PDC_PCI_UPDATE_CONFIG_DELAY () {8;}' unless defined(&PDC_PCI_UPDATE_CONFIG_DELAY);
    eval 'sub PDC_PCI_PCI_PATH_TO_PCI_HPA () {9;}' unless defined(&PDC_PCI_PCI_PATH_TO_PCI_HPA);
    eval 'sub PDC_PCI_PCI_HPA_TO_PCI_PATH () {10;}' unless defined(&PDC_PCI_PCI_HPA_TO_PCI_PATH);
    eval 'sub PDC_PCI_PCI_PATH_TO_PCI_BUS () {11;}' unless defined(&PDC_PCI_PCI_PATH_TO_PCI_BUS);
    eval 'sub PDC_PCI_PCI_RESERVED () {12;}' unless defined(&PDC_PCI_PCI_RESERVED);
    eval 'sub PDC_PCI_PCI_INT_ROUTE_SIZE () {13;}' unless defined(&PDC_PCI_PCI_INT_ROUTE_SIZE);
    eval 'sub PDC_PCI_GET_INT_TBL_SIZE () { &PDC_PCI_PCI_INT_ROUTE_SIZE;}' unless defined(&PDC_PCI_GET_INT_TBL_SIZE);
    eval 'sub PDC_PCI_PCI_INT_ROUTE () {14;}' unless defined(&PDC_PCI_PCI_INT_ROUTE);
    eval 'sub PDC_PCI_GET_INT_TBL () { &PDC_PCI_PCI_INT_ROUTE;}' unless defined(&PDC_PCI_GET_INT_TBL);
    eval 'sub PDC_PCI_READ_MON_TYPE () {15;}' unless defined(&PDC_PCI_READ_MON_TYPE);
    eval 'sub PDC_PCI_WRITE_MON_TYPE () {16;}' unless defined(&PDC_PCI_WRITE_MON_TYPE);
    eval 'sub PDC_INITIATOR () {163;}' unless defined(&PDC_INITIATOR);
    eval 'sub PDC_GET_INITIATOR () {0;}' unless defined(&PDC_GET_INITIATOR);
    eval 'sub PDC_SET_INITIATOR () {1;}' unless defined(&PDC_SET_INITIATOR);
    eval 'sub PDC_DELETE_INITIATOR () {2;}' unless defined(&PDC_DELETE_INITIATOR);
    eval 'sub PDC_RETURN_TABLE_SIZE () {3;}' unless defined(&PDC_RETURN_TABLE_SIZE);
    eval 'sub PDC_RETURN_TABLE () {4;}' unless defined(&PDC_RETURN_TABLE);
    eval 'sub PDC_LINK () {165;}' unless defined(&PDC_LINK);
    eval 'sub PDC_LINK_PCI_ENTRY_POINTS () {0;}' unless defined(&PDC_LINK_PCI_ENTRY_POINTS);
    eval 'sub PDC_LINK_USB_ENTRY_POINTS () {1;}' unless defined(&PDC_LINK_USB_ENTRY_POINTS);
    eval 'sub OS_ID_NONE () {0;}' unless defined(&OS_ID_NONE);
    eval 'sub OS_ID_HPUX () {1;}' unless defined(&OS_ID_HPUX);
    eval 'sub OS_ID_LINUX () { &OS_ID_HPUX;}' unless defined(&OS_ID_LINUX);
    eval 'sub OS_ID_MPEXL () {2;}' unless defined(&OS_ID_MPEXL);
    eval 'sub OS_ID_OSF () {3;}' unless defined(&OS_ID_OSF);
    eval 'sub OS_ID_HPRT () {4;}' unless defined(&OS_ID_HPRT);
    eval 'sub OS_ID_NOVEL () {5;}' unless defined(&OS_ID_NOVEL);
    eval 'sub OS_ID_NT () {6;}' unless defined(&OS_ID_NT);
    eval 'sub OSTAT_OFF () {0;}' unless defined(&OSTAT_OFF);
    eval 'sub OSTAT_FLT () {1;}' unless defined(&OSTAT_FLT);
    eval 'sub OSTAT_TEST () {2;}' unless defined(&OSTAT_TEST);
    eval 'sub OSTAT_INIT () {3;}' unless defined(&OSTAT_INIT);
    eval 'sub OSTAT_SHUT () {4;}' unless defined(&OSTAT_SHUT);
    eval 'sub OSTAT_WARN () {5;}' unless defined(&OSTAT_WARN);
    eval 'sub OSTAT_RUN () {6;}' unless defined(&OSTAT_RUN);
    eval 'sub OSTAT_ON () {7;}' unless defined(&OSTAT_ON);
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/types.ph';
	eval 'sub PDC_TYPE_ILLEGAL () {-1;}' unless defined(&PDC_TYPE_ILLEGAL);
	eval 'sub PDC_TYPE_PAT () {0;}' unless defined(&PDC_TYPE_PAT);
	eval 'sub PDC_TYPE_SYSTEM_MAP () {1;}' unless defined(&PDC_TYPE_SYSTEM_MAP);
	eval 'sub PDC_TYPE_SNAKE () {2;}' unless defined(&PDC_TYPE_SNAKE);
	eval 'sub PDC_MODEL_IOPDIR_FDC () {(1<< 2);}' unless defined(&PDC_MODEL_IOPDIR_FDC);
	eval 'sub PDC_MODEL_NVA_MASK () {(3<< 4);}' unless defined(&PDC_MODEL_NVA_MASK);
	eval 'sub PDC_MODEL_NVA_SUPPORTED () {(0<< 4);}' unless defined(&PDC_MODEL_NVA_SUPPORTED);
	eval 'sub PDC_MODEL_NVA_SLOW () {(1<< 4);}' unless defined(&PDC_MODEL_NVA_SLOW);
	eval 'sub PDC_MODEL_NVA_UNSUPPORTED () {(3<< 4);}' unless defined(&PDC_MODEL_NVA_UNSUPPORTED);
	if(defined(&__LP64__)) {
	}
	if(defined(&__LP64__)) {
	}
	if(0) {
	}
	unless(defined(&CONFIG_PA20)) {
	}
	if(defined(&__LP64__)) {
	}
	unless(defined(&CONFIG_PA20)) {
	}
    }
    eval 'sub PF_AUTOBOOT () {0x80;}' unless defined(&PF_AUTOBOOT);
    eval 'sub PF_AUTOSEARCH () {0x40;}' unless defined(&PF_AUTOSEARCH);
    eval 'sub PF_TIMER () {0xf;}' unless defined(&PF_TIMER);
    unless(defined(&__ASSEMBLY__)) {
    }
    eval 'sub CL_NULL () {0;}' unless defined(&CL_NULL);
    eval 'sub CL_RANDOM () {1;}' unless defined(&CL_RANDOM);
    eval 'sub CL_SEQU () {2;}' unless defined(&CL_SEQU);
    eval 'sub CL_DUPLEX () {7;}' unless defined(&CL_DUPLEX);
    eval 'sub CL_KEYBD () {8;}' unless defined(&CL_KEYBD);
    eval 'sub CL_DISPL () {9;}' unless defined(&CL_DISPL);
    eval 'sub CL_FC () {10;}' unless defined(&CL_FC);
    if(0) {
	eval 'sub DEVCLASS_RANDOM () {1;}' unless defined(&DEVCLASS_RANDOM);
	eval 'sub DEVCLASS_SEQU () {2;}' unless defined(&DEVCLASS_SEQU);
	eval 'sub DEVCLASS_DUPLEX () {7;}' unless defined(&DEVCLASS_DUPLEX);
	eval 'sub DEVCLASS_KEYBD () {8;}' unless defined(&DEVCLASS_KEYBD);
	eval 'sub DEVCLASS_DISP () {9;}' unless defined(&DEVCLASS_DISP);
    }
    eval 'sub ENTRY_INIT_SRCH_FRST () {2;}' unless defined(&ENTRY_INIT_SRCH_FRST);
    eval 'sub ENTRY_INIT_SRCH_NEXT () {3;}' unless defined(&ENTRY_INIT_SRCH_NEXT);
    eval 'sub ENTRY_INIT_MOD_DEV () {4;}' unless defined(&ENTRY_INIT_MOD_DEV);
    eval 'sub ENTRY_INIT_DEV () {5;}' unless defined(&ENTRY_INIT_DEV);
    eval 'sub ENTRY_INIT_MOD () {6;}' unless defined(&ENTRY_INIT_MOD);
    eval 'sub ENTRY_INIT_MSG () {9;}' unless defined(&ENTRY_INIT_MSG);
    eval 'sub ENTRY_IO_BOOTIN () {0;}' unless defined(&ENTRY_IO_BOOTIN);
    eval 'sub ENTRY_IO_BOOTOUT () {1;}' unless defined(&ENTRY_IO_BOOTOUT);
    eval 'sub ENTRY_IO_CIN () {2;}' unless defined(&ENTRY_IO_CIN);
    eval 'sub ENTRY_IO_COUT () {3;}' unless defined(&ENTRY_IO_COUT);
    eval 'sub ENTRY_IO_CLOSE () {4;}' unless defined(&ENTRY_IO_CLOSE);
    eval 'sub ENTRY_IO_GETMSG () {9;}' unless defined(&ENTRY_IO_GETMSG);
    eval 'sub ENTRY_IO_BBLOCK_IN () {16;}' unless defined(&ENTRY_IO_BBLOCK_IN);
    eval 'sub ENTRY_IO_BBLOCK_OUT () {17;}' unless defined(&ENTRY_IO_BBLOCK_OUT);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub PAGE0 () {( &__PAGE_OFFSET);}' unless defined(&PAGE0);
    }
    eval 'sub BOOT_CONSOLE_HPA_OFFSET () {0x3c0;}' unless defined(&BOOT_CONSOLE_HPA_OFFSET);
    eval 'sub BOOT_CONSOLE_SPA_OFFSET () {0x3c4;}' unless defined(&BOOT_CONSOLE_SPA_OFFSET);
    eval 'sub BOOT_CONSOLE_PATH_OFFSET () {0x3a8;}' unless defined(&BOOT_CONSOLE_PATH_OFFSET);
    unless(defined(&__ASSEMBLY__)) {
	unless(defined(&CONFIG_PA20)) {
	}
	if(defined(&__LP64__)) {
	}
    }
}
1;
