require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_PARISC_PTRACE_H)) {
    eval 'sub _PARISC_PTRACE_H () {1;}' unless defined(&_PARISC_PTRACE_H);
    require 'linux/types.ph';
    eval 'sub task_regs {
        my($task) = @_;
	    eval q(( (($task) +  &TASK_REGS)));
    }' unless defined(&task_regs);
    eval 'sub PTRACE_SINGLEBLOCK () {12;}' unless defined(&PTRACE_SINGLEBLOCK);
    if(defined(&__KERNEL__)) {
	eval 'sub user_mode {
	    my($regs) = @_;
    	    eval q(((($regs)-> $iaoq[0] & 3) ? 1: 0));
	}' unless defined(&user_mode);
	eval 'sub user_space {
	    my($regs) = @_;
    	    eval q(((($regs)-> $iasq[1] != 0) ? 1: 0));
	}' unless defined(&user_space);
	eval 'sub instruction_pointer {
	    my($regs) = @_;
    	    eval q((($regs)-> $iaoq[0] & ~3));
	}' unless defined(&instruction_pointer);
	eval 'sub profile_pc {
	    my($regs) = @_;
    	    eval q( &instruction_pointer($regs));
	}' unless defined(&profile_pc);
    }
}
1;
