require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_RTC_H__)) {
    eval 'sub __ASM_RTC_H__ () {1;}' unless defined(&__ASM_RTC_H__);
    if(defined(&__KERNEL__)) {
	require 'linux/rtc.ph';
	require 'asm/pdc.ph';
	eval 'sub SECS_PER_HOUR () {(60* 60);}' unless defined(&SECS_PER_HOUR);
	eval 'sub SECS_PER_DAY () {( &SECS_PER_HOUR * 24);}' unless defined(&SECS_PER_DAY);
	eval 'sub RTC_PIE () {0x40;}' unless defined(&RTC_PIE);
	eval 'sub RTC_AIE () {0x20;}' unless defined(&RTC_AIE);
	eval 'sub RTC_UIE () {0x10;}' unless defined(&RTC_UIE);
	eval 'sub RTC_BATT_BAD () {0x100;}' unless defined(&RTC_BATT_BAD);
	eval 'sub RTC_SQWE () {0x8;}' unless defined(&RTC_SQWE);
	eval 'sub RTC_DM_BINARY () {0x4;}' unless defined(&RTC_DM_BINARY);
	eval 'sub RTC_24H () {0x2;}' unless defined(&RTC_24H);
	eval 'sub RTC_DST_EN () {0x1;}' unless defined(&RTC_DST_EN);
	eval 'sub __isleap {
	    my($year) = @_;
    	    eval q((($year) % 4== 0 && (($year) % 100!= 0|| ($year) % 400== 0)));
	}' unless defined(&__isleap);
	eval 'sub get_rtc_time {
	    my($wtime) = @_;
    	    eval q({ \'struct pdc_tod\'  &tod_data; my $days,  &rem,  &y;  &const my $int * &ip;  &if( &pdc_tod_read( &tod_data) < 0)  &RTC_24H |  &RTC_BATT_BAD;  $days =  ($tod_data->{tod_sec}) /  &SECS_PER_DAY;  &rem =  ($tod_data->{tod_sec}) %  &SECS_PER_DAY;  ($wtime->{tm_hour}) =  &rem /  &SECS_PER_HOUR;  &rem %=  &SECS_PER_HOUR;  ($wtime->{tm_min}) =  &rem / 60;  ($wtime->{tm_sec}) =  &rem % 60;  &y = 1970;  &define  &DIV( &a,  &b) (( &a) / ( &b) - (( &a) % ( &b) < 0))  &define  &LEAPS_THRU_END_OF( &y) ( &DIV ( &y, 4) -  &DIV ( &y, 100) +  &DIV ( &y, 400))  &while ( $days < 0||  $days >= ( &__isleap ? 366: 365)) { my $yg =  &y +  $days / 365- ( $days % 365< 0);  $days -= (( $yg -  &y) * 365+  &LEAPS_THRU_END_OF ( $yg - 1) -  &LEAPS_THRU_END_OF ( &y - 1));  &y =  $yg; }  ($wtime->{tm_year}) =  &y - 1900;  &ip =  $__mon_yday[ &__isleap];  &for ( &y = 11;  $days <  $ip[ &y]; -- &y)  &continue;  $days -=  $ip[ &y];  ($wtime->{tm_mon}) =  &y;  ($wtime->{tm_mday}) =  $days + 1;  &RTC_24H; });
	}' unless defined(&get_rtc_time);
	eval 'sub get_rtc_ss {
	    my($void) = @_;
    	    eval q({ \'struct rtc_time\'  &h;  &get_rtc_time( &h);  ($h->{tm_sec}); });
	}' unless defined(&get_rtc_ss);
	eval 'sub get_rtc_pll {
	    my($pll) = @_;
    	    eval q({ - &EINVAL; });
	}' unless defined(&get_rtc_pll);
	eval 'sub set_rtc_pll {
	    my($pll) = @_;
    	    eval q({ - &EINVAL; });
	}' unless defined(&set_rtc_pll);
    }
}
1;
